SystemOrganization addCategory: #'HV-base'!
SystemOrganization addCategory: #'HV-sample6'!
SystemOrganization addCategory: #'HV-sample4'!
SystemOrganization addCategory: #'HV-sample3'!
SystemOrganization addCategory: #'HV-sample1'!
SystemOrganization addCategory: #'HV-sample2'!
SystemOrganization addCategory: #'HV-sample5'!

!HttpResponse class methodsFor: '*hv-fixes' stamp: 'gk 11/3/2003 13:17'!
fromRedirect: redirect
	"Hmmm, not sure - this code is old..."

	| tmp |
	^self new
		status: #tempMoved;
		fieldAt: 'Location' put: (tmp _ redirect fullHttpUrl);
		fieldAt: 'Pragma' put: 'no-cache';
		fieldAt: 'Cache-Control' put: 'private';
		contentType: MIMEDocument contentTypeHtml;
		contents: (ReadStream on: '<head><title>Object moved</title></head>
<body><h1>Object Moved</h1>This object may be found <a HREF="', tmp,'">here</a>.</body>');
		yourself! !

!HttpResponse class methodsFor: '*hv-fixes' stamp: 'gk 10/22/2003 16:10'!
redirectTo: url
	"Create a redirection response."

	^(HttpResponse
			status: #tempMoved
			contents: 'Temporarily moved to: <A HREF="', url, '">', url, '</A>')
		fieldAt: 'Location' put: url;
		fieldAt: 'URI' put: url; yourself! !

Object subclass: #HVCascadingStyleSheet
	instanceVariableNames: 'string'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVCascadingStyleSheet class methodsFor: 'instance creation' stamp: 'gh 8/30/2002 10:56'!
string: aString
	^self new string: aString! !

!HVCascadingStyleSheet methodsFor: 'as yet unclassified' stamp: 'gh 10/14/2002 16:39'!
asHttpResponseTo: request

	^HttpResponse new
		status: #ok;
		contentType: MIMEDocument contentTypeTextCSS;
		contents: (ReadStream on: string);
		yourself! !

!HVCascadingStyleSheet methodsFor: 'accessing' stamp: 'gh 9/18/2002 13:18'!
string
	^string! !

!HVCascadingStyleSheet methodsFor: 'accessing' stamp: 'gh 8/30/2002 10:26'!
string: aString
	string _ aString! !

Object subclass: #HVHtmlBuilder
	instanceVariableNames: 'request view isPost fields elements variables forms elementStack maxCol currentCol'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlBuilder commentStamp: '<historical>' prior: 0!
HVHtmlBuilder builds HTML pages and handles HTML Forms. It has a reference to the HVHttpView that created it (for various services) and to the request of that view.

Typical use is to instantiate it (HVHttpView has a method #builder which creates one), feed it "build messages" and then finally calling #render which will stream out the resulting HTML page. This is an example:

builder _ self builder.
builder start; h1: 'A heading'; postForm; inputText: #name; submit; endForm; end.
builder render

During the build some of the "build messages" return objects that can be used for input and output - typically objects representing Forms, Inputfields, Submit buttons etc. The messages #postForm, #inputText: and #submit all returned objects in the code above but the code chose to ignore them.

The contents message causes the builder to assemble the finished HTML document and return it as a String, but normally you just return the builder itself since HVHtmlBuilder also implements #asHttpResponseTo: which means that it can be returned as a result to Comanche from an 'url' method in a HVHttpView class. So you do not need to call #render and actually, in order to compose pages from multiple methods it is better if you do not call #render.

...

elements - An OrderedCollection holding all elements that constitute the page.
elementStack - An OrderedCollection acting as a stack for certain elements like for example forms.

!

!HVHtmlBuilder class methodsFor: 'instance creation' stamp: 'gh 1/31/2002 14:41'!
request: aRequest view: aView
	^self new request: aRequest view: aView; yourself! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 5/14/2002 10:27'!
addForm: aForm
	"Add the form both to the list of forms in this builder,
	the element stack and to the list of elements to render.
	The form is also given an id for this page."

	forms addLast: aForm.
	aForm id: forms size.
	elementStack addLast: aForm.
	^elements add: aForm

! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gh 2/22/2002 13:21'!
addHtmlInput: aVar
	"Add the input variable in the correct Form and
	also add it to the collection of elements."

	self currentForm add: aVar.
	^elements add: aVar

! !

!HVHtmlBuilder methodsFor: 'variables' stamp: 'gh 2/15/2002 14:39'!
addVar: aVar
	"Add the variable in the correct Form and
	add it to the collection of elements."

	self currentForm add: aVar.
	^elements add: aVar

! !

!HVHtmlBuilder methodsFor: 'comanche' stamp: 'gh 5/28/2002 10:30'!
asHttpResponseTo: req
	"We implement this so that a builder can be returned as a
	result from a method rather than a HTML String.
	This also enables nestling of builders in order to compose
	pages by calling other 'submethods'."

	^(HttpResponse fromString: self render)
		fieldAt: 'Pragma' put: 'no-cache';
		fieldAt: 'Cache-Control' put: 'no-cache'
		! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gh 2/15/2002 14:11'!
asString
	^self render! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gh 6/12/2002 10:36'!
at: var ifAbsent: block
	"Low level access to fields - parameters to GET or POST."

	^fields at: var ifAbsent: [^block value]! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 8/1/2002 17:18'!
b: text
	text class == String ifTrue:[^elements add: '<b>', text, '</b>'].
	elements add: '<b>'.
	text value: self.
	elements add: '</b>'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 10/18/2002 14:19'!
blockquote
	elements add: '<blockquote>'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 10/18/2002 14:18'!
blockquote: text
	text class == String ifTrue:[^elements add: '<blockquote>', text, '</blockquote>'].
	elements add: '<blockquote>'.
	text value: self.
	elements add: '</blockquote>'! !

!HVHtmlBuilder methodsFor: 'variables' stamp: 'gh 6/12/2002 10:35'!
bodytag
	"This is a way to be able to customize the body.
	Perhaps there are much better ways but this was simple."
	
	^variables at: #bodytag ifAbsent: [nil]

! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gh 6/12/2002 10:36'!
booleanAt: var ifAbsent: block
	"Customized version for checkboxes."

	^(fields at: var ifAbsent: [^block value]) = 'on'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 2/8/2002 15:59'!
br
	^elements add: '<br />'! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gh 5/30/2002 12:12'!
cell
	elements add: '<td class="tdp">'! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gh 5/22/2002 11:58'!
cell: text
	text class == BlockContext ifFalse:[^elements add: '<td>', text, '</td>'].
	elements add: '<td>'.
	text value: self.
	elements add: '</td>'! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gh 5/30/2002 12:32'!
cellCenter
	elements add: '<td class="tdpcenter">'! !

!HVHtmlBuilder methodsFor: 'html-alignment' stamp: 'gh 9/13/2002 15:49'!
colTab
	currentCol = maxCol
		ifTrue:[elements add: '</td></tr><tr><td>'.
				currentCol _ 1]
		ifFalse:[	elements add: '</td><td>'.
				currentCol _ currentCol + 1]! !

!HVHtmlBuilder methodsFor: 'html-alignment' stamp: 'gh 10/9/2002 15:17'!
colTabTop
	currentCol = maxCol
		ifTrue:[elements add: '</td></tr><tr valign="top"><td>'.
				currentCol _ 1]
		ifFalse:[	elements add: '</td><td>'.
				currentCol _ currentCol + 1]! !

!HVHtmlBuilder methodsFor: 'html-alignment' stamp: 'gh 10/11/2002 13:21'!
columns: cols
	elements add: '<table border="0" cellpadding="0" cellspacing="3"><tr><td>'.
	maxCol _ cols.
	currentCol _ 1! !

!HVHtmlBuilder methodsFor: 'html-alignment' stamp: 'gh 11/18/2002 15:22'!
columns: cols heads: heads
	elements add: '<table border="0" cellpadding="2" cellspacing="3">'.
	self heads: heads.
	elements add: '<tr><td>'.
	maxCol _ cols.
	currentCol _ 1! !

!HVHtmlBuilder methodsFor: 'html-alignment' stamp: 'gh 10/11/2002 13:21'!
columnsWide: cols
	elements add: '<table border="0" cellpadding="0" cellspacing="3" width="100%"><tr><td>'.
	maxCol _ cols.
	currentCol _ 1! !

!HVHtmlBuilder methodsFor: 'html-alignment' stamp: 'gh 10/11/2002 13:21'!
columnsWideTop: cols
	elements add: '<table border="0" cellpadding="0" cellspacing="3" width="100%"><tr  valign="top"><td>'.
	maxCol _ cols.
	currentCol _ 1! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gh 2/15/2002 14:52'!
currentForm
	"Find current form by looking in the stack.
	We could probably cache currentForm..."

	elementStack reverseDo: [:e | e isForm ifTrue:[^e]].
	^nil

! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gh 5/30/2002 09:46'!
data
	elements add: '<td class="tdp">'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 10/18/2002 13:35'!
divClass: aString
	"Start a div with a class."

	| div |
	elementStack addLast: (div _ HVHtmlDiv class: aString).
	^elements add: div! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 10/18/2002 13:35'!
divId: anId
	"Start a div with an id."

	| div |
	elementStack addLast: (div _ HVHtmlDiv id: anId).
	^elements add: div! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 1/31/2002 14:43'!
end
	^elements add: '</body></html>'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 10/18/2002 14:19'!
endBlockquote
	elements add: '</blockquote>'! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gh 5/30/2002 12:12'!
endCell
	elements add: '</td>'! !

!HVHtmlBuilder methodsFor: 'html-alignment' stamp: 'gh 9/13/2002 15:49'!
endColumns
	elements add: '</td></tr></table>'! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gh 5/30/2002 09:46'!
endData
	elements add: '</td>'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 10/18/2002 13:28'!
endDiv
	^self endTag! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/15/2002 14:52'!
endForm
	^self endTag! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gh 5/27/2002 16:58'!
endP
	elements add: '</p>'! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gh 5/22/2002 12:16'!
endRow
	elements add: '</tr>'! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gh 5/22/2002 12:16'!
endTable
	elements add: '</table>'! !

!HVHtmlBuilder methodsFor: 'variables' stamp: 'gh 1/15/2002 16:30'!
endTag
	"We assume that the last element on the stack is the correct one."

	^elements add: (HVHtmlEndtag for: elementStack removeLast)! !

!HVHtmlBuilder methodsFor: 'variables' stamp: 'gh 9/12/2002 13:23'!
findVar: aName
	"Find a named variable."

	^variables at: aName ifAbsent: [nil]! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 13:16'!
getForm
	"Start a GET form that will return to the same url as this request."

	^self addForm: (HVHtmlForm getAction: request url)! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 9/12/2002 16:06'!
getImage: url
	"Embed an image."

	^'<img src="', url, '" alt="no description" />'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 10/16/2002 16:03'!
getImage: url description: desc
	"Embed an image."

	^'<img src="', url, '" alt="', desc, '" />'! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gh 8/5/2002 13:54'!
getLink: url
	"Create a HTML link."

	^self getLink: url text: url! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gh 2/4/2002 14:42'!
getLink: url text: text
	"Create a HTML link."

	^'<a href="', url, '">', text, '</a>'! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gh 2/4/2002 14:43'!
getLinkLocal: relativeUrl text: text
	"Return a local HTML link to the view."

	^self getLink: view prefix, relativeUrl text: text! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 4/30/2002 09:39'!
green: text
	text class == String ifTrue:[^elements add:'<font color="green">', text, '</font>'].
	elements add: '<font color="green">'.
	text value: self.
	elements add: '</font>'! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gh 5/30/2002 12:27'!
greyRow
	elements add: '<tr class="trgrey">'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 8/5/2003 10:13'!
h1: text
	^self heading: text start: '<h1>' end: '</h1>'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 8/5/2003 10:13'!
h2: text
	^self heading: text start: '<h2>' end: '</h2>'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 8/5/2003 10:13'!
h3: text
	^self heading: text start: '<h3>' end: '</h3>'! !

!HVHtmlBuilder methodsFor: 'composition' stamp: 'gh 2/4/2002 16:45'!
head
	"Create and return a subbuilder for the head of the document.
	This is a variable reserved automatically in #start."

	| child |
	self var: #head value: (child _ HVHtmlBuilder request: request view: view).
	child title: view title.
	^child! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 8/5/2003 10:12'!
heading: text start: startTag end: endTag
	text class == String ifTrue:[^elements add: startTag, text, endTag].
	elements add: startTag.
	text numArgs = 0
		ifTrue:[ text value ]
		ifFalse:[ text value: self].
	elements add: endTag! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gh 10/9/2002 15:38'!
heads: heads
	"Add heads to a table that has already been started."

	elements add: '<head>'.
	heads do: [:head | elements add: '<th align="left">', head, '</th>'].
	elements add: '</head>'
! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 2/8/2002 15:59'!
hr
	^elements add: '<hr />'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 1/31/2002 15:47'!
html: aString
	^elements add: aString! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 10/8/2002 14:42'!
i: text
	text class == String ifTrue:[^elements add: '<i>', text, '</i>'].
	elements add: '<i>'.
	text value: self.
	elements add: '</i>'! !

!HVHtmlBuilder methodsFor: 'html-forms-queries' stamp: 'gh 9/16/2002 14:44'!
ifPost: aBlock
	"If it is a POST we run the block."

	^self isPost ifTrue:[aBlock value]! !

!HVHtmlBuilder methodsFor: 'html-forms-queries' stamp: 'gh 2/5/2002 09:36'!
ifSubmit: aBlock
	"If it is a POST or a GET with fields we run the block."

	request isPostRequest ifTrue:[^aBlock value].
	request isGetRequest ifTrue:[request getFields isEmpty ifFalse:[^aBlock value]]! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 10/9/2002 10:38'!
image: url
	"Embed an image."

	^self image: url description: 'no description'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 10/9/2002 10:37'!
image: url description: desc
	"Embed an image."

	^elements add: '<img src="', url, '" alt="', desc, '" />'! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 13:18'!
inputCheckbox
	"Add a checkbox, name is autogenerated and default value is false (unchecked)."

	^self inputCheckbox: self nextVarName value: false

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 13:18'!
inputCheckbox: name
	"Add a checkbox, use if you need to supply your own name.
	Default value is false (unchecked)."

	^self inputCheckbox: name value: false

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 13:20'!
inputCheckbox: name value: default
	"Add a checkbox named <name> with default value <default>.
	The value should be false or true. If the current request has
	posted this field then the value is picked from there."

	| val |
	val _ default.
	self ifSubmit: [
		val _ (fields includesKey: name)
			ifTrue:[ (fields at: name) = 'on' ]
			ifFalse: [ false ]].
	^self addHtmlInput: (HVHtmlInputCheckbox name: name value: val)! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 13:20'!
inputCheckboxValue: default
	"Add a checkbox, name is autogenerated and default value is <default>.
	false is unchecked and true is checked."

	^self inputCheckbox: self nextVarName value: default

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/29/2003 13:15'!
inputFile
	"Add an input file control so that a file can be chosen
	and included with the form. The form must be a multipart
	form - see #postFormMultiPart."

	^self inputFile: self nextVarName value: false

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/29/2003 13:16'!
inputFile: name
	"Add an input file control so that a file can be chosen
	and included with the form. The form must be a multipart
	form - see #postFormMultiPart."

	^self inputFile: name value: false

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/29/2003 13:16'!
inputFile: name value: default 
	"Add an input file control so that a file can be chosen
	and included with the form. The form must be a multipart
	form - see #postFormMultiPart."

	^self addHtmlInput: (HVHtmlInputFile name: name value: (fields at: name ifAbsent:[default]))


! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/29/2003 13:16'!
inputFileValue: default
	"Add an input file control so that a file can be chosen
	and included with the form. The form must be a multipart
	form - see #postFormMultiPart."

	^self inputFile: self nextVarName value: default

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 13:22'!
inputHidden
	"Add a hidden field, name is autogenerated and default value is ''."

	^self inputHidden: self nextVarName value: ''
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 13:23'!
inputHidden: name
	"Add a hidden field, use if you need to supply your own name.
	Default value is ''."

	^self inputHidden: name value: ''
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 13:23'!
inputHidden: var value: default 
	"Add a hidden field named <name> with default value <default>.
	The value should be a String. If the current request has
	posted this field then the value is picked from there."

	^self addHtmlInput: (HVHtmlInputHidden name: var value: (fields at: var ifAbsent:[default]))

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 13:24'!
inputHiddenValue: default
	"Add a hidden field, name is autogenerated and default value is <default>.
	The value should be a String."

	^self inputHidden: self nextVarName value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 13:57'!
inputNumber
	"Add a number field, name is autogenerated and default value is 0."

	^self inputNumber: self nextVarName value: 0

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 13:58'!
inputNumber: name
	"Add a number field, use if you need to supply your own name.
	Default value is 0."

	^self inputNumber: name value: 0

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 13:58'!
inputNumber: name size: size
	"Add a number field, use if you need to supply
	your own name and size of field. Default value is 0."

	^self inputNumber: name size: size value: 0
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 14:00'!
inputNumber: name size: size value: default 
	"Add a number field named <name> with default value <default>
	and length of field to be <size>.
	The value should be a Number. If the current request has
	posted this field then the value is picked from there."

	^self addHtmlInput: (HVHtmlInputNumber name: name value:
		(fields at: name ifAbsent:[default ifNil: [0]]) size: size)

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 14:01'!
inputNumber: name value: value
	"Add a number field, use if you need to supply your own name
	and default value, which should be a Number. Size defaults to 20."

	^self inputNumber: name size: 20 value: value

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 14:02'!
inputNumberSize: size
	"Add a number field with size <size>, name is autogenerated and default value is 0."

	^self inputNumber: self nextVarName size: size value: 0
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 14:02'!
inputNumberSize: size value: default
	"Add a number field with size <size> and default value <default>
	which should be a Number. Name is autogenerated."

	^self inputNumber: self nextVarName size: size value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 14:03'!
inputNumberValue: default
	"Add a number field with default value <default> which should
	be a Number. Size defaults to 20 and name is autogenerated."

	^self inputNumber: self nextVarName size: 20 value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 14:04'!
inputPassword
	"Add a password field which is like a text field that does not
	show the entered characters. Name is autogenerated and default value is ''."

	^self inputPassword: self nextVarName value: ''

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/16/2002 01:01'!
inputPassword: name

	^self inputPassword: name value: ''

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/16/2002 01:01'!
inputPassword: name size: size

	^self inputPassword: name size: size value: ''
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/4/2002 17:38'!
inputPassword: name size: size value: default 

	^self addHtmlInput: (HVHtmlInputPassword name: name value: (fields at: name ifAbsent:[default]) size: size)


! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/16/2002 01:02'!
inputPassword: name value: default

	^self inputPassword: name size: 30 value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/4/2002 17:38'!
inputPasswordSize: size

	^self inputPassword: self nextVarName size: size value: ''
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/16/2002 00:10'!
inputText

	^self inputText: self nextVarName value: ''

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 1/31/2002 15:55'!
inputText: var

	^self inputText: var value: ''

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/5/2002 09:20'!
inputText: var size: size

	^self inputText: var size: size value: ''
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/22/2002 13:58'!
inputText: name size: size value: default 

	^self addHtmlInput: (HVHtmlInputText name: name value: (fields at: name ifAbsent:[default]) size: size)


! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/1/2002 13:37'!
inputText: var value: default

	^self inputText: var size: 30 value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/15/2002 14:00'!
inputTextSize: size

	^self inputText: self nextVarName size: size value: ''
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'JO 3/4/2002 14:13'!
inputTextSize: size value: default

	^self inputText: self nextVarName size: size value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/21/2002 15:58'!
inputTextValue: default

	^self inputText: self nextVarName value: default

! !

!HVHtmlBuilder methodsFor: 'html-forms-queries' stamp: 'gh 9/16/2002 14:44'!
isPost
	"Is it a POST?"

	^request isPostRequest! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gh 5/30/2002 12:34'!
lightGreyRow
	elements add: '<tr class="trlgrey">'! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gh 1/31/2002 15:56'!
link: url text: text
	"Embed a HTML link."

	^elements add: '<a href="', url, '">', text, '</a>'! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gh 2/1/2002 13:15'!
linkBack
	"Return a local backlink."

	^self linkBack: 'Back'! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gh 1/31/2002 15:56'!
linkBack: text
	"Return a local backlink."

	^self link: view prefix text: text! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gh 3/21/2002 16:02'!
linkBackParent
	"Return a parent backlink."

	^self link: view parent prefix text: 'Back'! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gh 2/4/2002 14:20'!
linkBackParent: text
	"Return a parent backlink."

	^self link: view parent prefix text: text! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gh 2/12/2002 11:12'!
linkLocal: relativeUrl text: text
	"Make a local HTML link to the view."

	^self link: view prefix, relativeUrl text: text! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gh 2/5/2002 08:43'!
linkPrefix: prefix text: text
	"Embed a link to the view with that prefix."

	| target |
	target _ view.
	[target prefix = prefix ifTrue:[ ^self link: target prefix text: text ].
	target _ target parent.
	target notNil] whileTrue.
	^self link: prefix text: 'No view found for this link'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 3/20/2002 18:08'!
nbsp
	^elements add: '&nbsp;'! !

!HVHtmlBuilder methodsFor: 'variables' stamp: 'gh 5/14/2002 10:24'!
nextVarName
	"The current Form enumerates it's own variables."

	^self currentForm nextVarName
! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gh 6/12/2002 10:40'!
numberAt: var ifAbsent: block
	"Customized version to get an expected number."

	^(fields at: var ifAbsent: [^block value]) asNumber! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 4/24/2002 14:11'!
ol: items
	"Make an ordered list by using asString on the elements."
	
	^self ol: items do: [:i | self html: i asString ]! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 2/12/2002 11:07'!
ol: items do: aBlock
	"Make an ordered list but we let the block
	add the item to the builder itself."
	
	elements add: '<ol>'.
	items do: [:i |
		elements add: '<li>'.
		aBlock value: i.
		elements add: '</li>' ].
	elements add: '</ol>'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 2/12/2002 11:09'!
ol: items extract: aBlock
	"Make an ordered list with the value of the block
	as the item, use #ol:do: for fancier stuff."
	
	elements add: '<ol>'.
	items do: [:i | elements add: '<li>', (aBlock value: i), '</li>' ].
	elements add: '</ol>'! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gh 5/27/2002 16:58'!
p
	elements add: '<p>'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 2/8/2002 15:59'!
p: text
	text class == String ifTrue:[^elements add: '<p>', text, '</p>'].
	elements add: '<p>'.
	text value: self.
	elements add: '</p>'! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 6/12/2002 10:40'!
postForm
	"Start a POST form with an action url that is
	the same as this request."

	^self addForm: (HVHtmlForm postAction: request url)! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 1/15/2003 15:03'!
postFormLocal: aString
	"Start a POST form with an action url based
	on the local view."

	^self addForm: (HVHtmlForm postAction: view baseUrl, aString)! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 10/3/2002 17:32'!
postFormMultiPart
	"Start a POST form with an action url that is
	the same as this request and with encoding as multi part."

	^self addForm: (HVHtmlForm postAction: request url enctype: 'multipart/form-data')! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 10/4/2002 11:30'!
postFormMultiPartLocal: aString
	"Start a POST form with an action url that is
	based on the view and with encoding as multi part."

	^self addForm: (HVHtmlForm postAction: view prefix, aString enctype: 'multipart/form-data')! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 3/21/2002 14:44'!
pre: text
	text class == String ifTrue:[^elements add: '<pre>', text, '</pre>'].
	elements add: '<pre>'.
	text value: self.
	elements add: '</pre>'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 4/24/2002 14:20'!
red: text
	text class == String ifTrue:[^elements add:'<font color="red">', text, '</font>'].
	elements add: '<font color="red">'.
	text value: self.
	elements add: '</font>'! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gh 8/3/2002 02:19'!
render
	"Concatenate everything together and substituting variables
	in the progress. First we check if we are timing this page.
	If we are then we need to calculate the stop time and incorporate
	the time at the bottom of the page."

	| start stream |
	start _ request propertyAt: #startTime ifAbsent: [nil].
	start ifNotNil: [elements removeLast ].
	stream _ WriteStream on: (String new: 50000).
	elements do: [:element |
		(element isKindOf: String)
			ifTrue:[ stream nextPutAll: element ]
			ifFalse:[ element renderFullOn: stream ]].
	start ifNotNil: [
		stream nextPutAll: '<br><font size=-1>Time in ms: ', (Time millisecondClockValue - start) asString, '</font>', String crlf.
		^stream contents
	].
	^stream contents

! !

!HVHtmlBuilder methodsFor: 'accessing' stamp: 'gh 9/12/2002 16:02'!
request
	^request! !

!HVHtmlBuilder methodsFor: 'initialize-release' stamp: 'gk 11/3/2003 13:07'!
request: aRequest view: aView

	view _ aView.
	request _ aRequest.
	isPost _ request isPostRequest.
	isPost
		ifTrue: [fields _ request postFields]
		ifFalse: [fields _ request getFields].
	elements _ OrderedCollection new: 1000.
	elementStack _ OrderedCollection new.
	forms _ OrderedCollection new.
	variables _ Dictionary new! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/1/2002 13:12'!
reset

	^self reset: 'Reset'
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 9/12/2002 10:29'!
reset: text

	^elements add: '<input type="reset" value="', text, '" />'
! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gh 5/24/2002 10:15'!
row
	elements add: '<tr>'! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 5/22/2002 17:46'!
select: aName objects: objects nilLabel: label value: default

	^self select: aName objects: objects size: 1 nilLabel: label value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 8/15/2003 15:11'!
select: aName objects: objects size: size nilLabel: label value: default
	"Selects always have values that are integers from 1.
	If there is a value submitted we find the object at that
	position, otherwise we use the supplied default value."

	^self select: aName objects: objects values: nil size: size multiple: false nilLabel: label selector: nil value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 8/15/2003 15:14'!
select: aName objects: objects size: size value: default
	^self select: aName objects: objects values: nil size: size multiple: false nilLabel: #None selector: nil value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 5/16/2002 12:46'!
select: aName objects: objects value: default

	^self select: aName objects: objects size: 1 value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 8/15/2003 15:18'!
select: aName objects: objects values: values size: size multiple: multi nilLabel: label selector: sel value: default
	"Selects always have values that are integers from 1.
	If there is a value submitted we find the object at that
	position, otherwise we use the supplied default value."

	| val submitted v |
	submitted _ fields at: aName ifAbsent:[nil].
	submitted
		ifNotNil: [
			values
				ifNil: [
					(submitted isString not | multi)
						ifTrue:[val _ OrderedCollection new.
							submitted isString ifTrue: [
								submitted _ submitted findTokens: Character space].
							submitted
								do: [:subm |
									v _ objects at: subm asNumber ifAbsent: [nil].
									v ifNotNil: [val add: v]]]
						ifFalse:[val _ objects at: submitted asNumber ifAbsent: [nil]]]
				ifNotNil: [
					multi
						ifTrue: [submitted isString ifTrue: [
									submitted _ submitted findTokens: Character space].
								val _ submitted]
						ifFalse: [val _ submitted].
					(val = 'nil') ifTrue:[val _ nil].
					]]
		ifNil: [val _ default].
	^self addHtmlInput: (HVHtmlSelect name: aName objects: objects values: values size: size multiple: multi nilLabel: label selector: sel value: val)
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 5/16/2002 12:49'!
selectObjects: objects

	^self select: self nextVarName objects: objects size: 1 value: nil! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 8/15/2003 15:14'!
selectObjects: objects selector: aSymbol

	^self select: self nextVarName objects: objects values: nil size: 1 multiple: false nilLabel: #None selector: aSymbol value: nil! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 5/16/2002 12:46'!
selectObjects: objects value: default

	^self select: self nextVarName objects: objects size: 1 value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 5/16/2002 12:57'!
selectObjectsFirstSelected: objects

	^self select: self nextVarName objects: objects size: 1 value: (objects isEmpty ifTrue:[nil] ifFalse:[objects first])! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 8/15/2003 15:15'!
selectObjectsFirstSelected: objects selector: sel

	^self select: self nextVarName objects: objects values: nil size: 1 multiple: false nilLabel: #None selector: sel value: (objects isEmpty ifTrue:[nil] ifFalse:[objects first])! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 8/15/2003 15:15'!
selectObjectsFirstSelected: objects values: values

	^self select: self nextVarName objects: objects values: values size: 1 multiple: false nilLabel: #None selector: nil value: (objects isEmpty ifTrue:[nil] ifFalse:[values first])! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 5/16/2002 14:32'!
selectObjectsNilFirst: objects

	^self select: self nextVarName objects: (objects copy addFirst: nil; yourself) size: 1 value: nil! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 5/21/2002 16:15'!
selectObjectsNilFirst: objects nilLabel: label

	^self select: self nextVarName objects: (objects copy addFirst: nil; yourself) size: 1 nilLabel: label value: nil! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 8/15/2003 15:15'!
selectObjectsNilFirst: objects nilLabel: label selector: sel value: default

	^self select: self nextVarName objects: (objects asOrderedCollection addFirst: nil; yourself) values: nil size: 1 multiple: false nilLabel: label selector: sel value: default! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 5/21/2002 16:15'!
selectObjectsNilFirst: objects nilLabel: label value: default

	^self select: self nextVarName objects: (objects asOrderedCollection addFirst: nil; yourself) size: 1 nilLabel: label value: default! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 5/16/2002 14:39'!
selectObjectsNilFirst: objects value: default

	^self select: self nextVarName objects: (objects asOrderedCollection addFirst: nil; yourself) size: 1 value: default! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 8/15/2003 15:15'!
selectObjectsNilFirst: objects values: values nilLabel: label

	^self select: self nextVarName objects: (objects copy addFirst: nil; yourself) values: (values copy addFirst: nil; yourself) size: 1 multiple: false nilLabel: label selector: nil value: nil! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gh 2/4/2002 15:13'!
srcLink
	| url slash |
	(request url = view prefix)
		ifTrue:[ url _ request url, '/srcdefault' ]
		ifFalse:[	slash _ request url findLast: [:c | c = $/ ].
			url _ (request url copyFrom: 1 to: slash), 'src', (request url copyFrom: slash + 1 to: request url size)].
	^self html: '<font size=-1>'; link: url text: 'See source for this page'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 6/12/2002 10:42'!
start
	"Start the HTML page by embedding two variables,
	head and body with normal default values."

	elements add: '<html><head>'.
	self var: #head value: '<title>', view title, '</title>'.
	elements add: '</head>'.
	self var: #bodytag value: '<body>'! !

!HVHtmlBuilder methodsFor: 'composition' stamp: 'gh 5/10/2002 16:40'!
subBuilder
	"Create and return a subbuilder."

	| child |
	self var: self nextVarName value: (child _ HVHtmlBuilder request: request view: view).
	child title: view title.
	^child! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/1/2002 13:12'!
submit

	^self submit: 'Submit'
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/29/2003 15:08'!
submit: text

	^self submit: self nextVarName value: text
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/29/2003 15:47'!
submit: name value: text

	| val |
	val _ false.
	self ifSubmit: [
		val _ (fields includesKey: name)
			ifTrue:[ (fields at: name) = text ]
			ifFalse: [ false ]].
	^self addHtmlInput: (HVHtmlInputSubmit name: name value: text pressed: val)! !

!HVHtmlBuilder methodsFor: 'html-forms-queries' stamp: 'gk 10/29/2003 15:50'!
submitted: aString
	"Low level access - is a certain field available?
	To check for button presses, keep the button and
	use #ifPressed: or #pressed."

	fields at: aString ifAbsent: [^false].
	^true! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gh 5/30/2002 13:04'!
tab
	elements add: '</td><td class="tdp">'! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gh 5/30/2002 09:17'!
table
	elements add: '<table border="0">'! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gh 10/3/2002 17:43'!
table: objects heads: heads block: aBlock
	"Add a table. Efficient implementation but the extraction
	block <aBlock> can not use the builder."

	elements add: '<table border="1">'.
	self heads: heads.
	objects do: [:obj |
		elements add: '<tr>'.
		(aBlock value: obj) do: [:val |
			elements add: '<td>', val asString, '</td>' ].
		elements add: '</tr>'.
	].
	elements add: '</table>'
! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gh 6/12/2002 10:43'!
table: objects heads: heads cellBlock: aBlock
	"Add a table. This version takes a 2-argument (object and builder)
	block which feeds the cell values into the builder using #cell:."

	elements add: '<table border="1"><head>'.
	heads do: [:head | elements add: '<th>', head, '</th>'].
	elements add: '</head>'.
	objects do: [:obj |
		elements add: '<tr>'.
		aBlock value: obj value: self.
		elements add: '</tr>'.
	].
	elements add: '</table>'! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gh 5/30/2002 12:26'!
tableHeads: heads
	"Add a table. Use #row, #cell, #endRow, #endCell, #endTable."

	elements add: '<table border="0"><head>'.
	heads do: [:head | elements add: '<th class="thgrey">', head, '</th>'].
	elements add: '</head>'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 2/1/2002 12:59'!
tag: tag around: text
	text class == String ifTrue:[^elements add: '<',tag,'>', text, '<',tag,'>'].
	elements add: '<',tag,'>'.
	text value: self.
	elements add: '<',tag,'>'! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 11:37'!
textArea

	^self textArea: self nextVarName rows: 5 cols: 40 value: ''! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/16/2002 01:07'!
textArea: name

	^self textArea: name rows: 5 cols: 40 value: ''! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/1/2002 13:32'!
textArea: var rows: rows cols: cols

	^self textArea: var rows: rows cols: cols value: ''! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/19/2002 21:01'!
textArea: name rows: rows cols: cols value: default

	^self addHtmlInput: (HVHtmlTextArea name: name rows: rows cols: cols value: (fields at: name ifAbsent:[default]))
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/1/2002 13:32'!
textArea: var value: default

	^self textArea: var rows: 4 cols: 20 value: default! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/19/2002 21:06'!
textAreaRows: rows cols: cols

	^self textArea: self nextVarName rows: rows cols: cols value: ''! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 7/31/2002 09:33'!
textAreaRows: rows cols: cols value: default

	^self textArea: self nextVarName rows: rows cols: cols value: default! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 2/4/2002 16:44'!
title: text
	text class == String ifTrue:[^elements add: '<title>', text, '</title>'].
	elements add: '<title>'.
	text value: self.
	elements add: '</title>'! !

!HVHtmlBuilder methodsFor: 'special-toc' stamp: 'gh 9/12/2002 13:17'!
toc
	"Return an empty table of contents."

	^self tocValue: nil
! !

!HVHtmlBuilder methodsFor: 'special-toc' stamp: 'gh 9/12/2002 14:10'!
toc: aName value: aValue
	"Return a table of contents with a given name and value."

	| var |
	var _ HVTableOfContents name: aName value: aValue builder: self.
	variables at: aName put: var.
	^elements add: var

! !

!HVHtmlBuilder methodsFor: 'special-toc' stamp: 'gh 9/12/2002 13:21'!
tocValue: aValue
	"Return a table of contents with a given value."

	^self toc: variables size fullPrintString value: aValue

! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 4/24/2002 14:11'!
ul: items
	"Make an unordered list by using asString on the elements."
	
	^self ul: items do: [:i | self html: i asString ]! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 4/24/2002 14:10'!
ul: items do: aBlock
	"Make an unordered list but we let the block
	add the item to the builder itself."

	elements add: '<ul>'.
	items do: [:i |
		elements add: '<li>'.
		aBlock value: i.
		elements add: '</li>' ].
	elements add: '</ul>'! !

!HVHtmlBuilder methodsFor: 'variables' stamp: 'gh 3/15/2002 21:35'!
var
	"Return a variable node. The name will be a single number.
	A variable node can be given content using #value:
	later on after the page has been built but before it is rendered."

	^self var: (variables size fullPrintString) value: ''
! !

!HVHtmlBuilder methodsFor: 'variables' stamp: 'gh 2/22/2002 13:07'!
var: aName
	"Return a variable node.
	A variable node can be given content using #value:
	later on after the page has been built."

	^self var: aName value: ''
! !

!HVHtmlBuilder methodsFor: 'variables' stamp: 'gh 3/15/2002 21:32'!
var: aName value: aValue
	"Return a variable node.
	A variable node can be given content using #value:
	later on after the page has been built."

	| var |
	var _ HVSimpleVariable name: aName value: aValue.
	variables at: aName put: var.
	^elements add: var

! !

!HVHtmlBuilder methodsFor: 'accessing' stamp: 'gh 10/18/2002 15:30'!
view
	^view! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gh 6/6/2002 13:27'!
zebraTable: objects heads: heads block: aBlock
	"Add a table. Efficient implementation but the extraction
	block <aBlock> can not use the builder."

	| even row |
	elements add: '<table border="0"><head>'.
	heads do: [:head | elements add: '<th class="thgrey">', head, '</th>'].
	elements add: '</head>'.
	even _ false.
	objects do: [:obj |
		row _ aBlock value: obj.
		row ifNotNil: [
			even
				ifTrue: [ elements add: '<tr class="trgrey">']
				ifFalse: [ elements add: '<tr class="trlgrey">'].
			even _ even not.
			row do: [:val | elements add: '<td class="tdp">', val asString, '</td>' ].
			elements add: '</tr>'
		]
	].
	elements add: '</table>'
! !

Object subclass: #HVHtmlElement
	instanceVariableNames: 'prefix suffix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlElement commentStamp: 'gh 6/12/2002 10:44' prior: 0!
Base class for all elements, nothing much yet.!

HVHtmlElement subclass: #HVHtmlDiv
	instanceVariableNames: 'class id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlDiv class methodsFor: 'instance creation' stamp: 'gh 10/18/2002 13:34'!
class: aString
	^self new class: aString! !

!HVHtmlDiv class methodsFor: 'instance creation' stamp: 'gh 10/18/2002 13:34'!
id: anId
	^self new id: anId! !

!HVHtmlDiv methodsFor: 'accessing' stamp: 'gh 10/18/2002 13:34'!
class
	^class! !

!HVHtmlDiv methodsFor: 'accessing' stamp: 'gh 10/18/2002 13:34'!
class: aString
	class _ aString! !

!HVHtmlDiv methodsFor: 'accessing' stamp: 'gh 10/18/2002 13:33'!
id
	^id! !

!HVHtmlDiv methodsFor: 'accessing' stamp: 'gh 10/18/2002 13:33'!
id: anId
	id _ anId! !

!HVHtmlDiv methodsFor: 'rendering' stamp: 'gh 10/18/2002 13:32'!
renderEndOn: stream

	stream nextPutAll: '</div>'! !

!HVHtmlDiv methodsFor: 'rendering' stamp: 'gh 10/18/2002 14:14'!
renderOn: stream

	stream nextPutAll: '<div '.
	id ifNotNil: [stream nextPutAll: 'id="', id, '"'].
	class ifNotNil: [stream nextPutAll: 'class="', class, '"'].
	stream nextPut: $>! !

!HVHtmlElement methodsFor: 'decorations' stamp: 'gk 10/31/2003 11:24'!
error: aString
	"Add <aString> formatted as an error in bold red as suffix."

	self suffix: '&nbsp;<b><font color="red">', aString, '</font></b>'! !

!HVHtmlElement methodsFor: 'testing' stamp: 'gh 2/15/2002 14:41'!
isForm
	^false! !

!HVHtmlElement methodsFor: 'accessing' stamp: 'gh 8/3/2002 02:22'!
prefix: aString
	prefix _ aString! !

!HVHtmlElement methodsFor: 'rendering' stamp: 'gh 8/3/2002 02:25'!
renderFullOn: aStream
	"Any prefix/suffix is added if they are not nil."

	prefix ifNotNil: [aStream nextPutAll: prefix].
	self renderOn: aStream.
	suffix ifNotNil: [aStream nextPutAll: suffix]! !

!HVHtmlElement methodsFor: 'decorations' stamp: 'gh 8/3/2002 02:23'!
success: aString
	"Add <aString> formatted as a message in bold green as suffix."

	suffix _ '&nbsp;<b><font color="green">', aString, '</font></b>'! !

!HVHtmlElement methodsFor: 'accessing' stamp: 'gh 8/3/2002 02:22'!
suffix: aString
	suffix _ aString! !

HVHtmlElement subclass: #HVHtmlForm
	instanceVariableNames: 'name action enctype method elements id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlForm commentStamp: 'gk 10/31/2003 13:12' prior: 0!
A Form.This object has a method for rendering and it keeps track of the ids of the fields in the form. Typically only used internally in HttpView.!

!HVHtmlForm class methodsFor: 'instance creation' stamp: 'gh 2/15/2002 14:53'!
getAction: action

	^self new action: action method: 'get' name: nil! !

!HVHtmlForm class methodsFor: 'instance creation' stamp: 'gh 2/15/2002 14:49'!
postAction: action

	^self new action: action method: 'post' name: nil! !

!HVHtmlForm class methodsFor: 'instance creation' stamp: 'gh 10/3/2002 17:30'!
postAction: action enctype: type

	^self new action: action method: 'post' name: nil; enctype: type! !

!HVHtmlForm methodsFor: 'initialize-release' stamp: 'gh 2/22/2002 13:26'!
action: anAction method: aMethod name: aName

	action _ anAction.
	method _ aMethod.
	name _ aName.
	elements _ OrderedCollection new! !

!HVHtmlForm methodsFor: 'elements' stamp: 'gh 2/22/2002 13:27'!
add: anHtmlElement
	^elements add: anHtmlElement! !

!HVHtmlForm methodsFor: 'accessing' stamp: 'gh 10/3/2002 17:29'!
enctype
	^enctype! !

!HVHtmlForm methodsFor: 'accessing' stamp: 'gh 10/3/2002 17:29'!
enctype: type
	enctype _ type! !

!HVHtmlForm methodsFor: 'accessing' stamp: 'gh 5/14/2002 10:28'!
id
	^id! !

!HVHtmlForm methodsFor: 'accessing' stamp: 'gh 5/14/2002 10:28'!
id: anId
	id _ anId! !

!HVHtmlForm methodsFor: 'testing' stamp: 'gk 10/31/2003 13:14'!
ifSubmit: aBlock
	"Should not be used."

	0 halt.! !

!HVHtmlForm methodsFor: 'testing' stamp: 'gh 2/15/2002 14:41'!
isForm
	^true! !

!HVHtmlForm methodsFor: 'elements' stamp: 'gk 10/31/2003 13:13'!
nextVarName
	"We take our own numeric id and tack on a numeric id for our elements."

	^(id fullPrintString, '-',  (elements size + 1) fullPrintString) asSymbol! !

!HVHtmlForm methodsFor: 'rendering' stamp: 'gh 1/15/2002 16:29'!
renderEndOn: stream

	stream nextPutAll: '</form>'! !

!HVHtmlForm methodsFor: 'rendering' stamp: 'gh 10/3/2002 17:33'!
renderOn: stream

	stream
		nextPutAll: '<form action="';
		nextPutAll: action;
		nextPutAll: '" method="', method, '"'.
	enctype ifNotNil: [stream nextPutAll: ' enctype="', enctype, '"'].
	stream nextPut: $>! !

HVHtmlElement subclass: #HVHtmlVariable
	instanceVariableNames: 'value name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlVariable commentStamp: 'gh 6/12/2002 10:54' prior: 0!
An abstract base class for elements that has a name and carry a value.

Can be used to embed dynamic values in HTML pages (subclass HVSimpleVariable) but it is also the base class for all Form elements like input fields etc.!

HVHtmlVariable subclass: #HVHtmlFormElement
	instanceVariableNames: 'readonly disabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlFormElement methodsFor: 'decorations' stamp: 'gk 8/8/2003 17:20'!
clearDisabled
	disabled _ nil! !

!HVHtmlFormElement methodsFor: 'decorations' stamp: 'gk 8/8/2003 17:21'!
clearReadonly
	readonly _ nil! !

!HVHtmlFormElement methodsFor: 'rendering' stamp: 'gk 8/8/2003 16:55'!
renderAttributesOn: stream
	"Render attributes."

	readonly ifNotNil: [stream nextPutAll: ' readonly'].
	disabled ifNotNil: [stream nextPutAll: ' disabled']! !

!HVHtmlFormElement methodsFor: 'decorations' stamp: 'gk 8/8/2003 16:57'!
setDisabled
	disabled _ true! !

!HVHtmlFormElement methodsFor: 'decorations' stamp: 'gk 8/8/2003 16:57'!
setReadonly
	readonly _ true! !

HVHtmlFormElement subclass: #HVHtmlInput
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlInput commentStamp: 'gh 6/12/2002 10:48' prior: 0!
Base class for all input elements, inherits the ability to carry a "value" and a "name" from HVHtmlVariable. Basic rendering.!

!HVHtmlInput methodsFor: 'accessing' stamp: 'gk 8/8/2003 16:22'!
readonly
	^readonly! !

!HVHtmlInput methodsFor: 'rendering' stamp: 'gk 8/8/2003 16:54'!
renderOn: stream

	stream nextPutAll: '<input'.
	stream nextPutAll: ' type="', self renderType, '" name="', name, '"'.
	self renderAttributesOn: stream.
	self renderValueOn: stream.
	stream nextPutAll: ' />'! !

!HVHtmlInput methodsFor: 'rendering' stamp: 'gh 4/3/2002 13:20'!
renderValueOn: stream

	stream nextPutAll: ' value="', value asString, '"'.! !

!HVHtmlInput methodsFor: 'accessing' stamp: 'gk 8/8/2003 16:22'!
setReadonly
	readonly _ true! !

HVHtmlInput subclass: #HVHtmlInputCheckbox
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlInputCheckbox commentStamp: 'gh 6/12/2002 10:47' prior: 0!
A Form checkbox. Simply a method for rendering.!

!HVHtmlInputCheckbox methodsFor: 'rendering' stamp: 'gh 1/15/2002 16:43'!
renderType
	^'checkbox'! !

!HVHtmlInputCheckbox methodsFor: 'rendering' stamp: 'gh 2/22/2002 14:00'!
renderValueOn: stream
	value ifTrue:[stream nextPutAll: ' checked']! !

HVHtmlInput subclass: #HVHtmlInputFile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlInputFile methodsFor: 'rendering' stamp: 'gh 10/3/2002 17:49'!
renderType

	^'file'! !

HVHtmlInput subclass: #HVHtmlInputHidden
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlInputHidden commentStamp: 'gh 6/12/2002 10:49' prior: 0!
Simply a hidden field.!

!HVHtmlInputHidden methodsFor: 'as yet unclassified' stamp: 'gh 3/16/2002 00:27'!
renderType

	^'hidden'! !

HVHtmlInput subclass: #HVHtmlInputSubmit
	instanceVariableNames: 'pressed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlInputSubmit commentStamp: 'gh 6/12/2002 10:50' prior: 0!
A submit button for a Form.!

!HVHtmlInputSubmit class methodsFor: 'instance creation' stamp: 'gk 10/29/2003 15:19'!
name: aName value: val pressed: pressed
	^(super name: aName value: val) pressed: pressed! !

!HVHtmlInputSubmit methodsFor: 'control' stamp: 'gk 10/29/2003 15:37'!
ifPressed: aBlock
	"Evaluate <aBlock> if this button was pressed -
	if the name of the button was submitted."

	^pressed ifTrue: [aBlock value]! !

!HVHtmlInputSubmit methodsFor: 'control' stamp: 'gk 10/31/2003 10:09'!
ifPressed: aBlock ifNot: anotherBlock
	"Evaluate <aBlock> if this button was pressed -
	if the name of the button was submitted.
	If not we evaluate <anotherBlock>."

	^pressed ifTrue: [aBlock value] ifFalse: [anotherBlock value]! !

!HVHtmlInputSubmit methodsFor: 'accessing' stamp: 'gk 10/29/2003 15:37'!
pressed
	^pressed! !

!HVHtmlInputSubmit methodsFor: 'accessing' stamp: 'gk 10/29/2003 15:36'!
pressed: aBoolean
	pressed _ aBoolean! !

!HVHtmlInputSubmit methodsFor: 'rendering' stamp: 'gh 5/14/2002 10:40'!
renderType
	^'submit'! !

HVHtmlInput subclass: #HVHtmlInputText
	instanceVariableNames: 'size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlInputText commentStamp: 'gh 6/12/2002 10:50' prior: 0!
A text input field for Forms.!

HVHtmlInputText subclass: #HVHtmlInputNumber
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlInputNumber commentStamp: 'gh 6/12/2002 10:49' prior: 0!
A special variant of HVHtmlInputText that returns a number.!

!HVHtmlInputNumber methodsFor: 'accessing' stamp: 'gh 3/16/2002 00:58'!
value
	^super value asNumber! !

!HVHtmlInputNumber methodsFor: 'accessing' stamp: 'gh 3/16/2002 00:58'!
value: aValue
	^super value: aValue fullPrintString! !

HVHtmlInputText subclass: #HVHtmlInputPassword
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlInputPassword commentStamp: 'gh 6/12/2002 10:50' prior: 0!
A password field for a Form.!

!HVHtmlInputPassword methodsFor: 'rendering' stamp: 'gh 3/4/2002 17:37'!
renderType

	^'password'! !

!HVHtmlInputText class methodsFor: 'instance creation' stamp: 'gh 2/22/2002 13:15'!
name: aName value: aValue size: aSize
	^super new name: aName value: aValue; size: aSize; yourself! !

!HVHtmlInputText methodsFor: 'rendering' stamp: 'gk 8/8/2003 16:56'!
renderAttributesOn: stream
	"Add the size attribute."

	super renderAttributesOn: stream.
	stream nextPutAll: ' size="'.
	size printOn: stream.
	stream nextPut: $"! !

!HVHtmlInputText methodsFor: 'rendering' stamp: 'gh 1/15/2002 16:43'!
renderType

	^'text'! !

!HVHtmlInputText methodsFor: 'accessing' stamp: 'gh 2/22/2002 13:15'!
size
	^size! !

!HVHtmlInputText methodsFor: 'accessing' stamp: 'gh 2/22/2002 13:15'!
size: aSize
	size _ aSize! !

HVHtmlFormElement subclass: #HVHtmlSelect
	instanceVariableNames: 'size objects values labels nilLabel labelSelector multiple'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlSelect commentStamp: 'gh 6/12/2002 10:50' prior: 0!
A drop down menu.!

!HVHtmlSelect class methodsFor: 'instance creation' stamp: 'gk 8/15/2003 15:13'!
name: aName objects: objects values: values size: size multiple: multi nilLabel: label selector: sel value: aValue 
	^super new name: aName value: aValue;
		objects: objects values: values size: size multiple: multi nilLabel: label selector: sel; yourself! !

!HVHtmlSelect methodsFor: 'accessing' stamp: 'gk 8/15/2003 12:38'!
multiple
	^multiple! !

!HVHtmlSelect methodsFor: 'accessing' stamp: 'gk 8/15/2003 12:39'!
multiple: aBoolean
	multiple _ aBoolean! !

!HVHtmlSelect methodsFor: 'accessing' stamp: 'gh 3/21/2002 14:56'!
objects
	^objects! !

!HVHtmlSelect methodsFor: 'accessing' stamp: 'gk 8/15/2003 15:14'!
objects: objs values: vals size: s multiple: multi nilLabel: label selector: sel
	objects _ objs.
	values _ vals.
	size _ s.
	nilLabel _ label.
	multiple _ multi.
	sel ifNil: [labelSelector _ #name] ifNotNil: [labelSelector _ sel]! !

!HVHtmlSelect methodsFor: 'accessing' stamp: 'gk 6/6/2003 15:27'!
renderOn: stream
	"Render the select as HTML."

	| current multiple |
	multiple _ self multiple.
	stream nextPutAll: '<select name="', name, '" size="', size printString , (multiple ifTrue: ['" multiple>'] ifFalse: ['">']).
	labels _ objects
				collect: [:obj |
					obj
						ifNil: [nilLabel]
						ifNotNil: [
							(obj isKindOf: String)
								ifTrue:[obj]
								ifFalse:[obj perform: labelSelector]]].
	1 to: objects size do: [:n |
		current _ values ifNil: [objects at: n] ifNotNil: [values at: n].
		(multiple ifTrue: [value includes: current] ifFalse: [current = value])
			ifTrue: [stream nextPutAll: '<option selected']
			ifFalse: [stream nextPutAll: '<option' ].
		stream nextPutAll: ' value="'.
		values ifNil: [n printOn: stream] ifNotNil: [stream nextPutAll: (values at: n) asString].
		stream nextPutAll: ' ">'.
		stream nextPutAll: (labels at: n).
		stream nextPutAll: '</option>'.
	].
	stream nextPutAll: '</select>'! !

!HVHtmlSelect methodsFor: 'accessing' stamp: 'gk 6/6/2003 15:17'!
selector: aSymbol
	labelSelector _ aSymbol! !

!HVHtmlSelect methodsFor: 'accessing' stamp: 'gh 3/21/2002 14:55'!
size
	^size! !

!HVHtmlSelect methodsFor: 'accessing' stamp: 'gh 3/21/2002 14:56'!
size: aSize
	size _ aSize! !

HVHtmlFormElement subclass: #HVHtmlTextArea
	instanceVariableNames: 'rows cols'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlTextArea commentStamp: 'gh 6/12/2002 10:51' prior: 0!
A textarea for Forms.!

!HVHtmlTextArea class methodsFor: 'instance creation' stamp: 'gh 3/19/2002 21:01'!
name: aName rows: rows cols: cols value: aValue
	^super new name: aName value: aValue; rows: rows cols: cols; yourself! !

!HVHtmlTextArea methodsFor: 'accessing' stamp: 'gh 3/19/2002 21:01'!
cols
	^cols! !

!HVHtmlTextArea methodsFor: 'accessing' stamp: 'gk 8/8/2003 16:21'!
readonly
	^readonly! !

!HVHtmlTextArea methodsFor: 'rendering' stamp: 'gk 8/8/2003 16:21'!
renderOn: stream

	stream nextPutAll: '<textarea name="', name, '" rows="', rows asString, '" cols="', cols asString, '"'.
	self renderAttributesOn: stream.
	stream nextPut: $>; nextPutAll: (value ifNil: ['']); nextPutAll: '</textarea>'
! !

!HVHtmlTextArea methodsFor: 'accessing' stamp: 'gh 3/19/2002 21:00'!
rows
	^rows! !

!HVHtmlTextArea methodsFor: 'private' stamp: 'gh 3/19/2002 21:00'!
rows: r cols: c
	rows _ r.
	cols _ c! !

!HVHtmlTextArea methodsFor: 'accessing' stamp: 'gk 8/8/2003 16:21'!
setReadonly
	readonly _ true! !

!HVHtmlVariable class methodsFor: 'instance creation' stamp: 'gh 2/22/2002 12:44'!
name: aName value: aValue
	^super new name: aName value: aValue; yourself! !

!HVHtmlVariable methodsFor: 'initialize-release' stamp: 'gh 2/15/2002 13:55'!
initialize
	! !

!HVHtmlVariable methodsFor: 'accessing' stamp: 'gh 2/15/2002 13:53'!
name
	^name! !

!HVHtmlVariable methodsFor: 'accessing' stamp: 'gh 2/15/2002 13:54'!
name: aName
	name _ aName! !

!HVHtmlVariable methodsFor: 'private' stamp: 'gh 2/22/2002 12:44'!
name: aName value: aValue
	name _ aName.
	value _ aValue! !

!HVHtmlVariable methodsFor: 'rendering' stamp: 'gh 2/22/2002 14:26'!
renderOn: stream
	"My subclasses should implement this."

	self subclassResponsibility ! !

!HVHtmlVariable methodsFor: 'accessing' stamp: 'gh 2/15/2002 13:53'!
value
	^value! !

!HVHtmlVariable methodsFor: 'accessing' stamp: 'gh 2/15/2002 13:53'!
value: aVal
	value _ aVal! !

HVHtmlVariable subclass: #HVSimpleVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVSimpleVariable commentStamp: 'gh 6/12/2002 10:55' prior: 0!
The concrete subclass of HVHtmlVariable that is used for embedding simple variables in HTML pages.!

!HVSimpleVariable methodsFor: 'rendering' stamp: 'gh 2/22/2002 14:26'!
renderOn: stream
	"My implementation is to just convert the value to a String."

	stream nextPutAll: value asString! !

HVSimpleVariable subclass: #HVTableOfContents
	instanceVariableNames: 'topEntries builder baseUrl openImageUrl closedImageUrl leafImageUrl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVTableOfContents classSide methodsFor: 'instance creation' stamp: 'gh 9/12/2002 14:07'!
name: aName value: aValue builder: aBuilder
	^super new name: aName value: aValue builder: aBuilder; yourself! !

!HVTableOfContents methodsFor: 'accessing' stamp: 'gh 9/17/2002 17:43'!
baseUrl: url
	baseUrl _ url! !

!HVTableOfContents methodsFor: 'initialize-release' stamp: 'gh 10/29/2002 09:52'!
baseUrl: base open: openDoc closed: closedDoc leaf: leafDoc
	openDoc ifNotNil: [openImageUrl _ base, openDoc fileName].
	closedDoc ifNotNil: [closedImageUrl _ base, closedDoc fileName].
	leafDoc ifNotNil: [leafImageUrl _ base, leafDoc fileName]! !

!HVTableOfContents methodsFor: 'rendering' stamp: 'gh 10/17/2002 15:25'!
closedImageUrl
	^closedImageUrl! !

!HVTableOfContents methodsFor: 'rendering' stamp: 'gh 10/18/2002 15:37'!
expanded
	"Return all names that should be expanded.
	We retrieve the cookie and convert it to a Set of Symbols."

	| attrs toc tocSym |
	tocSym _ builder view tocSymbol.
	attrs _ builder request session attributes.
	toc _ attrs at: tocSym ifAbsent:[attrs at: tocSym put: ''].
	^((toc findTokens: $,) collect: [:s | s asSymbol]) asSet
! !

!HVTableOfContents methodsFor: 'rendering' stamp: 'gh 9/17/2002 17:40'!
fullName
	^baseUrl! !

!HVTableOfContents methodsFor: 'rendering' stamp: 'gh 10/17/2002 15:25'!
leafImageUrl
	^leafImageUrl! !

!HVTableOfContents methodsFor: 'accessing' stamp: 'gh 9/12/2002 16:26'!
name: aName label: aLabel
	"Add a new top level entry in the TOC.
	Return the entry."

	^topEntries add: (HVTableOfContentsEntry name: aName label: aLabel parent: self)! !

!HVTableOfContents methodsFor: 'initialize-release' stamp: 'gh 10/17/2002 15:26'!
name: aName value: aValue builder: aBuilder
	topEntries _ OrderedCollection new.
	builder _ aBuilder.
	name _ aName.
	value _ aValue.
	openImageUrl _ '/static/open.gif'.
	closedImageUrl _ '/static/closed.gif'.
	leafImageUrl _ '/static/leaf.gif'! !

!HVTableOfContents methodsFor: 'initialize-release' stamp: 'gh 10/17/2002 15:26'!
open: oUrl closed: cUrl leaf: lUrl
	openImageUrl _ oUrl.
	closedImageUrl _ cUrl.
	leafImageUrl _ lUrl! !

!HVTableOfContents methodsFor: 'rendering' stamp: 'gh 10/17/2002 15:24'!
openImageUrl
	^openImageUrl! !

!HVTableOfContents methodsFor: 'rendering' stamp: 'gh 9/13/2002 11:02'!
renderOn: stream
	"Render the TOC. If we are empty we act as a simple
	variable instead."

	| expanded |
	topEntries isEmpty ifTrue:[^super renderOn: stream]. "no items to render, take the value instead"
	expanded _ self expanded.
	topEntries do: [:entry |
		entry renderOn: stream expanded: expanded level: 0 builder: builder]
! !

Object subclass: #HVHtmlEndtag
	instanceVariableNames: 'element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlEndtag commentStamp: 'gh 6/12/2002 10:45' prior: 0!
An object representing an end-tag. Since it knows which element it is meant to "end" it can delegate the rendering.!

!HVHtmlEndtag classSide methodsFor: 'instance creation' stamp: 'gh 2/15/2002 14:34'!
for: element
	^self new element: element; yourself! !

!HVHtmlEndtag methodsFor: 'accessing' stamp: 'gh 2/15/2002 14:34'!
element: anElement
	element _ anElement! !

!HVHtmlEndtag methodsFor: 'rendering' stamp: 'gh 8/3/2002 02:27'!
renderFullOn: stream
	"We ask the element that we are the endmarker for
	to render it's 'end' on the stream."

	element renderEndOn: stream! !

Object subclass: #HVHttpView
	instanceVariableNames: 'prefix model'
	classVariableNames: 'UltraSafeChars HtmlEntities SafeChars'
	poolDictionaries: ''
	category: 'HV-base'!

!HVHttpView commentStamp: 'gk 10/24/2003 10:55' prior: 0!
A HVHttpView is a web user interface - it is an object that handles a HttpRequest and returns a result.

A view has a domain object as a model, and thus the HVHttpView hierarchy often typically mirrors the domain class hierarchy. It also has a reference to it's parent view which ultimately is a HVRootView.

A view is instantiated for every request which means that it does not have to care about multiple Processes (each view instance is only used by one Process - the one started to serve the request) - but since the model can be shared with other views either the model needs to care or the views needs to serialize their access to the model.

The HVRootView is not instantiated for every request - it represents the web application itself that is plugged into Komanche - so it must be written Process safe.

A view holds a reference to the request - 'req' - which it is given upon instantiation. Most of the interaction with the request is done easier through the use of an HVHtmlBuilder which has a lot of support for handling HTML Forms.

Based on the url the framework will call the method with the same name. These methods are kept by convention in the 'urls' category. If no method name is given in the url the default method #default is called. The methods should return something responds to #asHttpResponseTo:. The root view sends this message to the object returned and returns the result to Komanche which expects an HttpResponse.

String implements #asHttpResponseTo: so the simplest would be to just return a String with HTML in it. A better approach would be to use an HVHtmlBuilder. Look at the sample applications.

Finally HVHttpView includes some simple facilities for keeping track of the user and the current user account.!

!HVHttpView class methodsFor: 'start-stop' stamp: 'gk 10/24/2003 10:21'!
createModel
	"This is called when a HVRootView is created
	and no model has been specified.
	Default model is nil, override in subclass."

	^nil! !

!HVHttpView class methodsFor: 'start-stop' stamp: 'gk 10/24/2003 10:43'!
defaultAlias
	"This is called when a HVRootView is created
	and no alias has been specified.
	Default alias, override in subclass."

	^''! !

!HVHttpView class methodsFor: 'start-stop' stamp: 'gk 10/24/2003 10:25'!
defaultPort
	"This is called when a HVRootView is created
	and no port number has been specified.
	Default alias, override in subclass."

	^80! !

!HVHttpView class methodsFor: 'class initialization' stamp: 'gk 10/24/2003 10:19'!
initialize
	"HVHttpView initialize"

HtmlEntities _ (Dictionary new: 128)
		at: 'amp'	put: $&;
		at: 'lt'		put: $<;
		at: 'gt'		put: $>;
		at: 'quot'	put: $";
		at: 'euro'	put: Character euro;
		yourself.

SafeChars _ Set new.
('1234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ/-_()".,''@?!!:; ', '﻿åäöÅÄÖéüèáêôâ') do: [:c | SafeChars add: c].
UltraSafeChars _ SafeChars copy.
UltraSafeChars remove: $/; remove: $.



	"#('nbsp' 'iexcl' 'cent' 'pound' 'curren' 'yen' 'brvbar' 'sect' 'uml' 'copy' 'ordf' 'laquo' 'not' 'shy' 'reg' 'hibar' 'deg' 'plusmn' 'sup2' 'sup3' 'acute' 'micro' 'para' 'middot' 'cedil' 'sup1' 'ordm' 'raquo' 'frac14' 'frac12' 'frac34' 'iquest' 'Agrave' 'Aacute' 'Acirc' 'Atilde' 'Auml' 'Aring' 'AElig' 'Ccedil' 'Egrave' 'Eacute' 'Ecirc' 'Euml' 'Igrave' 'Iacute' 'Icirc' 'Iuml' 'ETH' 'Ntilde' 'Ograve' 'Oacute' 'Ocirc' 'Otilde' 'Ouml' 'times' 'Oslash' 'Ugrave' 'Uacute' 'Ucirc' 'Uuml' 'Yacute' 'THORN' 'szlig' 'agrave' 'aacute' 'acirc' 'atilde' 'auml' 'aring' 'aelig' 'ccedil' 'egrave' 'eacute' 'ecirc' 'euml' 'igrave' 'iacute' 'icirc' 'iuml' 'eth' 'ntilde' 'ograve' 'oacute' 'ocirc' 'otilde' 'ouml' 'divide' 'oslash' 'ugrave' 'uacute' 'ucirc' 'uuml' 'yacute' 'thorn' 'yuml' ) withIndexDo: [:each :index | HtmlEntities at: each put: (index + 159) asCharacter isoToSqueak]"! !

!HVHttpView class methodsFor: 'instance creation' stamp: 'gk 10/24/2003 10:32'!
on: aModel
	"Create a new view on a model."

	^super new model: aModel! !

!HVHttpView class methodsFor: 'start-stop' stamp: 'gk 10/24/2003 10:22'!
start
	"Start service on default port."

	^self startOn: self defaultPort! !

!HVHttpView class methodsFor: 'start-stop' stamp: 'gk 10/24/2003 10:22'!
startOn: portNum
	"Simplest way to start this view as a web app.
	We first create a root view that use us as default view class
	and then we start the root view."

	(HVRootView model: self createModel alias: self defaultAlias viewClass: self)
		startOn: portNum! !

!HVHttpView class methodsFor: 'start-stop' stamp: 'gk 10/24/2003 10:22'!
stop
	"Stop and unregister service with name of class."

	^(Service serviceNamed: self name) unregister! !

!HVHttpView class methodsFor: 'start-stop' stamp: 'gk 10/24/2003 10:23'!
stopAll
	"Stop and unregister all services."

	^Service services do: [:s | s unregister]! !

!HVHttpView methodsFor: 'initialize-release' stamp: 'gk 10/24/2003 10:30'!
initialize
	prefix _ ''
! !

!HVHttpView methodsFor: 'accessing' stamp: 'gk 10/24/2003 10:26'!
model
	^model! !

!HVHttpView methodsFor: 'accessing' stamp: 'gk 10/24/2003 10:26'!
model: aModel
	model _ aModel! !

!HVHttpView methodsFor: 'accessing' stamp: 'gk 10/24/2003 10:27'!
prefix: aString

	prefix _ aString! !

HVHttpView subclass: #HVRootView
	instanceVariableNames: 'viewClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVRootView commentStamp: 'gk 10/24/2003 10:53' prior: 0!
A HVRootView is a view object that is plugged into Komanche. It holds the model and it is the first entrypoint of a web application. The method #process: is called with a HttpRequest as an argument and Komanche expects a HttpResponse being returned.

The root view typically instantiates a transient view object on the model, put the request into the view and then sends #dispatch to it.

Eventually it will return a result object that is transformed into an HttpResponse.

Simple applications typically don't subclass HVRootView, instead an instance is created when the application is started, see for example HVHttpView class>>startOn:.!

!HVRootView class methodsFor: 'instance creation' stamp: 'gk 10/24/2003 09:08'!
alias: anAlias
	"This relies on model being set in initialize."

	^self model: nil alias: anAlias viewClass: nil! !

!HVRootView class methodsFor: 'instance creation' stamp: 'gk 10/24/2003 09:08'!
model: aModel
	"Create a persistent root view that can be plugged into Komanche."

	^self model: aModel alias: nil viewClass: nil! !

!HVRootView class methodsFor: 'instance creation' stamp: 'gk 10/24/2003 09:07'!
model: aModel alias: anAlias
	"Create a persistent root view that can be plugged into Komanche."

	^self model: aModel alias: anAlias viewClass: nil! !

!HVRootView class methodsFor: 'instance creation' stamp: 'gk 10/24/2003 10:33'!
model: aModel alias: anAlias viewClass: aViewClass
	"Create a persistent root view that can be plugged into Komanche."

	^(super on: aModel) prefix: anAlias viewClass: aViewClass! !

!HVRootView class methodsFor: 'instance creation' stamp: 'gk 10/24/2003 09:08'!
new
	"This relies on model and prefix being set in initialize."

	^self model: nil alias: nil viewClass: nil! !

!HVRootView class methodsFor: 'start-stop' stamp: 'gk 10/23/2003 13:46'!
start
	"Start service with name of class."

	^self new start! !

!HVRootView class methodsFor: 'start-stop' stamp: 'gk 10/23/2003 13:59'!
stop
	"Stop service with name of class."

	^(Service serviceNamed: self name) stop; unregister! !

!HVRootView methodsFor: 'initalize-release' stamp: 'gk 10/24/2003 10:41'!
initialize

	prefix _ ''! !

!HVRootView methodsFor: 'initalize-release' stamp: 'gk 10/24/2003 09:23'!
prefix: aPrefix viewClass: aClass

	self prefix: aPrefix.
	viewClass _ aClass! !

!HVRootView methodsFor: 'private' stamp: 'gk 10/24/2003 10:29'!
prefixOn: aStream
	"We are at the top and have no parent, just add prefix."

	prefix ifNotNil: [aStream nextPutAll: prefix]! !

!HVRootView methodsFor: 'comanche' stamp: 'gk 10/24/2003 10:44'!
process: request
	"Process the request. This is the method that is called by Comanche.
	We instantiate a view for our model and simply
	stick the request into him and let him take over."

	| url view |
	url _ request url.
	(url findString: 'tms') = 0 ifFalse:[
		request propertyAt: #startTime put: Time millisecondClockValue ].
	viewClass
		ifNotNil: [view _ viewClass on: model parent: self]
		ifNil: [(model respondsTo: #viewFor:)
				ifTrue: [view _ model viewFor: self]
				ifFalse: [self halt]].
	view request: request. "normally not needed when using #viewFor: but here it is"
	^(view dispatch) asHttpResponseTo: request! !

!HVRootView methodsFor: 'private' stamp: 'gk 10/24/2003 10:36'!
request
	"I am the root view and can not hold the request
	because I need to be Process safe."

	^nil! !

!HVRootView methodsFor: 'comanche' stamp: 'gk 10/23/2003 12:22'!
sessionTimedOut: session
	(model respondsTo: #sessionTimedOut:) ifTrue:[ model sessionTimedOut: session ]! !

!HVRootView methodsFor: 'start-stop' stamp: 'gk 10/24/2003 10:44'!
startOn: portNum
	"Simplest way to start this root view as a web app.
	Creates a new standalone http service with this root view plugged in."

	| ma name |
	name _ viewClass ifNil: [self class name] ifNotNil: [viewClass name].
	ma := ModuleAssembly core.
	prefix = ''
		ifTrue: [ma addPlug: [:request | self process: request]]
		ifFalse: [ma alias: prefix to: [ma addPlug: [:request | self process: request]]].
	(HttpService startOn: portNum named: name) plug: ma rootModule! !

HVHttpView subclass: #HVTransientView
	instanceVariableNames: 'parent title req'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVTransientView commentStamp: 'gk 10/23/2003 12:29' prior: 0!
A HVHttpView is a web user interface.

A view has a domain object as a model, and thus the VHHttpView hierarchy often typically mirrors the domain class hierarchy. It also has a reference to it's parent view which ultimately is a HVRootView.

A view is instantiated for every request which means that it does not have to care about multiple Processes (each view instance is only used by one Process - the one started to serve the request) - but since the model can be shared with other views either the model needs to care or the views needs to serialize their access to the model.

The HVRootView is not instantiated for every request - it represents the web application itself that is plugged into Komance - so it must be written Process safe.

A view holds a reference to the request - 'req' - which it is given upon instantiation. Most of the interaction with the request is done easier through the use of an HVHtmlBuilder which has a lot of support for handling HTML Forms.

Based on the url the framework will call the method with the same name. These methods are kept by convention in the 'urls' category. If no method name is given in the url the default method #default is called. The methods should return something responds to #asHttpResponseTo:. The root view sends this message to the object returned and returns the result to Komanche which expects an HttpResponse.

String implements #asHttpResponseTo: so the simplest would be to just return a String with HTML in it. A better approach would be to use an HVHtmlBuilder. Look at HVTodoListView for an example.

Finally HVHttpView includes some simple facilities for keeping track of the user and the current user account.!

HVTransientView subclass: #HVFileDirectoryView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-sample3'!

!HVFileDirectoryView commentStamp: 'gk 11/3/2003 13:09' prior: 0!
This web app just gives a file upload/delete user interface on a directory in a filesystem.
Methods commented in detail.!

!HVFileDirectoryView class methodsFor: 'as yet unclassified' stamp: 'gk 10/24/2003 15:48'!
createModel
	"This is called when the application is started."

	| dir dirName |
	dirName _ 'testdir'.
	dir _ FileDirectory default.
	(dir directoryExists: dirName)
		ifFalse: [dir createDirectory: dirName].
	^dir directoryNamed: dirName! !

!HVFileDirectoryView methodsFor: 'urls' stamp: 'gk 10/31/2003 10:53'!
default
	"Show the web page for uploading and deleting files."

	| b checkBoxes fn size deleteButton |
	"Create a HTML builder object."
	b _ self builder. 
	
	"Start the page, add a heading level 1."
	b start; h1: 'Files'.
	
	"Start a multipart form with a POST url to the local view instance + '/upload'.
	This will make the POST go the method #upload in this class."
	b postFormMultiPartLocal: '/upload'. 

	"Add an input file field and a submit button with the text 'Upload'.
	In this case we don't care to hold onto the button, the POST goes to the
	#upload method anyways."
	b inputFile; submit: 'Upload'.

	"Add a break making it look better, ending the form and starting a new
	form with no url specified - this makes the POST go to this method by default."
	b br; endForm; postForm.

	"Create a table with 3 columns and specify the column labels."
	b columns: 3 heads: #('Choose' 'Filename' 'Size').

	"Create a dictionary to hold the checkbox widgets for each file
	using the filename as the key."
	checkBoxes _ Dictionary new.

	model entries do: [:e |
		"For all entries in the directory we pick out filename and size."
		fn _ e first.
		size _ e last.

		"Add a checkbox to the page and take the resulting widget
		and stuff it into the dictionary using the filename as key."
		checkBoxes at: fn put: b inputCheckbox.

		"#colTab moves to the next column in the table, there we add
		a link for each file that will point to the #file method in this class
		with the filename added at the end of the url. #colTab also
		automatically moves to the next row in the table."
		b colTab; linkLocal: '/file/', fn text: fn; colTab;
			html: size printString; colTab].

	"End the table"
	b endColumns.

	"Add a delete button with label."
	deleteButton _ b submit: 'Delete selected files'.

	"End the form, add a horisontal ruler, a link to the source of this method
	and end the web page."
	b endForm; hr; srcLink; end.

	"Ok, if this was a POST of the second form the deleteButton will know it
	and the code will be run. We loop through all entries in the dictionary
	and depending on the #value of each checkbox we delete the file."
	deleteButton ifPressed: [
		checkBoxes keysAndValuesDo: [:name :box |
			box value ifTrue:[model deleteFileNamed: name]].

		"We have changed the model (deleted files) so instead of returning
		the page we just built above, because it contains rows for files
		that are now deleted - we issue a redirect causing a GET reload
		of this page."
		^self redirectToDefault].

	"Return the builder which will cause it to be converted to a HTTP response and thus
	have it render the page back to the user. The last thing HV does is to send #asHttpResponseTo:
	to the object returned from the page methods, see HVRootView>>process: which is the method
	called by Comanche."
	^b! !

!HVFileDirectoryView methodsFor: 'urls' stamp: 'gk 10/31/2003 10:50'!
file
	"Download a file."

	| fileName stream |
	"First we pick out the filename and turn the characters escaped by the browser back."
	fileName _ (self methodAfter: self prefix, '/file') unescapePercents.

	"If the filename is empty we use the inherited method #serverError to return a simple error page.
	Oterwise we open the file and if it exists we finally return the stream which will be converted
	into a HTTP response just before being returned to Comanche."
	fileName isEmpty
		ifTrue: [^self serverError: 'No filename specified in URL.']
		ifFalse:[[stream _ model oldFileNamed: fileName]
					on: FileDoesNotExistException
					do: [^self serverError: 'No file found with name: ', fileName]].
	^stream
! !

!HVFileDirectoryView methodsFor: 'initialize-release' stamp: 'gk 10/24/2003 13:15'!
initialize
	"We set the title of the view - it will show up as the page title.
	We also set the prefix of this view - in this case it is empty."

	title _ model pathName.
	prefix _ ''! !

!HVFileDirectoryView methodsFor: 'urls' stamp: 'gk 10/31/2003 11:03'!
upload
	"Upload a file."

	"Here we utilize an inherited convenience method to handle uploaded
	files. The block sent to #handleUpload: will be executed for each file
	uploaded. The block needs to take one argument - the filename, and
	should return a stream or nil. If a stream is returned the file contents
	will be written to it and then the stream will be closed. Returning nil
	ignores the file."
	self handleUpload: [:filename |
		"We simple first delete it if it exists and then return a FileStream
		so that the file gets written."
		(model fileExists: filename) ifTrue:[model deleteFileNamed: filename].
		model newFileNamed: filename].

	"We are done, redirect the user to the #default page."
	^self redirectToDefault! !

HVTransientView subclass: #HVHelloWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-sample1'!

!HVHelloWorld commentStamp: 'gk 11/3/2003 13:05' prior: 0!
This is the minimal web app in HttpView. You can start it with:

HVHelloWorld start

...and stop it:

HVHelloWorld stop

Surf in at http://localhost or http://localhost/hello to see it in action!!!

!HVHelloWorld methodsFor: 'urls' stamp: 'gk 11/3/2003 13:06'!
default
	"The shortest Hello World. String implements #asHttpResponseTo: so
	it will be converted to a proper HttpResponse when just before being
	handed back to Comanche."

	^'Hello world!!'! !

!HVHelloWorld methodsFor: 'urls' stamp: 'gk 10/29/2003 16:20'!
hello
	"A slightly longer version using HVHtmlBuilder."

	| builder |
	builder _ self builder.
	builder start; h1: 'Hello world!!'.
	builder p: 'It is a brand new day.'.
	builder hr; srcLink; end.
	^builder! !

HVTransientView subclass: #HVNagTool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-sample6'!

!HVNagTool commentStamp: 'gk 10/24/2003 11:40' prior: 0!
This class implements a very simple web app that maintains a more complex todo list with reminders etc.!

HVTransientView subclass: #HVSimpleForms
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-sample4'!

!HVSimpleForms commentStamp: 'gk 11/3/2003 13:10' prior: 0!
This class shows off most of the Forms abilities of HVHtmlBuilder.!

!HVSimpleForms methodsFor: 'urls' stamp: 'gk 10/31/2003 14:12'!
megaform1
	"Exercising some forms stuff."

	| b button checkbox checkbox2 code result codeResult |
	b _ self builder.
	b start; h1: 'Megaform'; postForm.

	"Add a checkbox, this box will either be unchecked for a normal GET
	or be checked if the user checks it and presses submit (a POST)."
	checkbox _ b html: 'Is Squeak great?'; inputCheckbox.

	"Add a checkbox, this box will be checked per default.
	If the form shows a proped model for editing typically we pick the value
	from the model object."
	checkbox2 _ b br; html: 'Does Java suck?'; inputCheckboxValue: true.

	b linkLocal: '/simplefield' text: 'simple field'.

	"Add a textarea."
	code _ b br; html: 'Enter some code:';br; textArea.

	"Add a paragraph."
	b p: 'Result of code:'.
	"Add a variable - it is simply a placeholder for some HTML."
	result _ b var.
	
	"Add two breaks and a submit button, end the form."
	button _ b br; br; submit: 'Hit me'.
	b endForm.

	"The values of the widgets can be both used and set even if this is not a POST.
	Check if checkbox2 is checked, it should be even on the first GET."
	checkbox2 value ifTrue: [checkbox2 suffix: 'Of course it does...'].

	"If there is no code, stuff some in there."
	code value isEmpty ifTrue: [code value: '3+4'].

	"Was the button pressed?"
	button ifPressed: [
		"If checkbox is checked we add some HTML as a prefix just before the checkbox.
		Note that the actual rendering of the page happens after this method has returned
		so we can manipulate the elements of the page at this point.
		The #error: method simply adds a suffix in red."
		checkbox value
			ifTrue: [checkbox prefix: ' You bet!! ']
			ifFalse: [checkbox error: '<- Come on, check it!!'].

		checkbox2 value
			ifTrue: [checkbox2 suffix: 'Right on!!']
			ifFalse: [checkbox2 error: '<- Come on, check it!!'].
	].
	b hr; srcLink; end.

	"Compile and execute the code. Note that I cobbled this together - I tried adding a bit
	of error handling etc. Not sure how to do this properly."
	codeResult _ [Compiler evaluate: code value logged: false] on: Exception do: [:ex |
						ex class = InMidstOfFileinNotification
							ifTrue: [ex resume: true]
							ifFalse: [ex return: ex]].

	"As a proof that the page is not yet rendered - we can finally stuff in the result of the code
	into the variable we embedded into the page."
	result value: codeResult printString.
	^b! !

!HVSimpleForms methodsFor: 'urls' stamp: 'gk 10/31/2003 14:05'!
megaform2
	"Exercising some forms stuff."

	| b button age years hidden lastAge pass pass2 |
	b _ self builder.
	b start; h1: 'Megaform 2'; postForm.
	b columns: 2.

	"Add a input field for a number. A number field is a simple subclass of text field."
	age _ b html: 'How old are you?'; colTab; inputNumber.

	"Add a input field for a number with a default value different than 0."
	years _ b colTab; html: 'How old is Squeak?'; colTab; inputNumberValue: 9.
	b endColumns.

	"Add a hidden field, see below."
	hidden _ b inputHidden.

	"Add a password."
	pass _ b br; html: 'Password: '; inputPassword.
	pass2 _ b br; html: 'Verify: '; inputPassword.
	
	"Add two breaks and a submit button, end the form."
	button _ b br; br; submit: 'Hit me'.
	b endForm.

	"Was the button pressed?"
	button ifPressed: [
		"Pick out the hidden field value, hidden fields hold Strings so we convert it to a number."
		lastAge _ hidden value asNumber.

		"We stuff the entered age into the hidden field. This means that we will get
		it back on next post - thus we 'remember' the age by storing it in the page."
		hidden value: age value.
	].

	b p: 'You are ', age value printString, ' years old. Last time you entered ',
			lastAge printString, ' years.'.
	b p: 'Squeak is ', years value printString, ' old.'.

	b hr; srcLink; end.
	^b! !

!HVSimpleForms methodsFor: 'urls' stamp: 'gk 10/31/2003 11:07'!
simplefield
	"This method is called when accessing http://localhost/hello.
	It is first called with a GET thus building the form with an empty
	text field and showing it. The #postForm defaults to an POST url
	pointing to this method again. So when the user press submit
	we end up here again and the form is built the second time.
	This time around the builder object sees that there is a value
	for the textfield and puts that into the HVHtmlInputText instance -
	this happens when the widget is created using the #inputText method,
	so that we can get it by sending #value to it later in the method."

	| builder field button |
	builder _ self builder.
	builder start; h1: 'Howdy!!'.
	builder p: 'What is your name?'.
	builder postForm.
	field _ builder inputText.
	button _ builder submit.
	builder endForm.
	builder p: 'Your name is ', (button ifPressed: [field value] ifNot:['unknown!!']), '!!'.
	builder hr; srcLink; end.
	^builder! !

HVTransientView subclass: #HVTodoListView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-sample2'!

!HVTodoListView commentStamp: 'gk 10/24/2003 11:03' prior: 0!
This is a minimal todo list web application.

The class side method #createModel is called once when the application is started. At that point a HVRootView is instantiated that holds the model and the root view is plugged into Komanche. This class is then instantiated for each request and has the root view as a parent.

This class implements a trivial initialize method in order to set the prefix and title of the webpage. It then implements two urls:

- The default page which shows the todolist and has a form for adding items and links for removing items.
- The removeitem page which is the method called when a remove link is clicked. It redirects back to the default page.

"Fire this app up on port 80"
HVTodoListView start

"Stop it"
HVTodoListView stop
!

!HVTodoListView class methodsFor: 'startup' stamp: 'gk 10/24/2003 11:00'!
createModel
	"This is called when the application is started."

	^HVTodoList new! !

!HVTodoListView methodsFor: 'urls' stamp: 'gk 10/24/2003 10:59'!
default
	"This is the default method that is run in an HVHttpView
	when no other method has been named in the url.
	It can also be reached by it's name 'default'."

	| b item count |
	b _ self builder.
	b start; h1: 'Todo list'.
	count _ 1.
	item _ b postForm; html: 'Add item: '; inputTextSize: 40.
	b submit; endForm.
	b ifSubmit: [
		model addItem: item value.
	].
	b ol: model items do: [:i |
		b linkLocal: '/removeitem?id=', count fullPrintString text: 'R'.
		b html: ' ', i.
		count _ count + 1].
	b hr; srcLink; end.
	^b! !

!HVTodoListView methodsFor: 'initialize-release' stamp: 'gk 10/23/2003 16:09'!
initialize
	"We set the title of the view - it will show up as the page title.
	We also set the prefix of this view - in this case it is empty."

	title _ 'Todo'.
	prefix _ ''! !

!HVTodoListView methodsFor: 'urls' stamp: 'gk 10/24/2003 10:59'!
removeitem
	"Remove an item in the todolist. We pick out
	the index from the url. When we are finished
	we do a redirect to default, which means that the
	web browser will reload the #default method in this view."

	| id removeItem |
	id _ (req getFields at: 'id') asNumber.
	removeItem _ model items at: id.
	model removeItem: removeItem.
	^self redirectToDefault! !

!HVTransientView class methodsFor: 'instance creation' stamp: 'gk 10/24/2003 10:32'!
on: aModel parent: aParent
	"Create a new view on a model and with aParent as parent view.
	This is normally done on the fly for each request."

	^(super on: aModel) initializeWith: aParent; yourself! !

!HVTransientView methodsFor: 'comanche' stamp: 'gh 1/15/2003 15:02'!
baseUrl
	"This is the base we use for urls in the rendered pages."

	^self prefix! !

!HVTransientView methodsFor: 'html creation' stamp: 'gh 2/8/2002 16:39'!
builder
	"Create a standard builder with our own request."

	^HVHtmlBuilder request: req view: self! !

!HVTransientView methodsFor: 'urls' stamp: 'gh 12/19/2002 10:38'!
collapsetoc
	"Collapse given entry by updating the session info on which entries to show."

	| entryName toc tocString tocSym |
	tocSym _ self tocSymbol.
	entryName _ req getFields at: #entry.
	toc _ req session attributes at: tocSym ifAbsent:[^self redirectToDefault].
	toc _ ((toc findTokens: $,) collect: [:s | s asSymbol]) asSet.
	toc remove: entryName asSymbol ifAbsent: [nil].
	tocString _ String streamContents: [:s |
		toc do: [:sym | s nextPutAll: sym, ',']].
	req session attributes at: tocSym put: tocString.
	^self redirectToDefault! !

!HVTransientView methodsFor: 'oldmethods' stamp: 'gh 1/18/2002 12:21'!
createSelectWidget: values name: name 
	"Create a select widget for forms."

	^self createSelectWidget: values selected: 1 name: name! !

!HVTransientView methodsFor: 'oldmethods' stamp: 'gh 1/18/2002 12:20'!
createSelectWidget: values selected: selected name: name 
	"Create a select widget for forms."

	^self createSelectWidget: values selected: selected name: name withIds: true
! !

!HVTransientView methodsFor: 'oldmethods' stamp: 'gh 1/18/2002 12:26'!
createSelectWidget: objects selected: selected name: name withIds: withIds
	"Create a select widget for forms."

	| obj id |
	^String streamContents: [:stream |
		stream nextPutAll: '<select name="', name, '" size="1">'.
		1 to: objects size do: [:n |
			obj _ objects at: n.
			withIds ifTrue:[ id _ obj id] ifFalse:[ id _ n].
			(id = selected)
				ifTrue: [ stream nextPutAll: '<option selected']
				ifFalse: [ stream nextPutAll: '<option' ].
			withIds
				ifTrue: [stream nextPutAll: ' value="', id fullPrintString, '">']
				ifFalse: [stream nextPut: $> ].
			stream nextPutAll: obj name; nextPutAll: '</option>'.
		].
		stream nextPutAll: '</select>']
! !

!HVTransientView methodsFor: 'comanche' stamp: 'gh 2/11/2002 18:00'!
currentAccount
	"Get the account for the request."

	^req session attributes at: #account ifAbsent: [nil]! !

!HVTransientView methodsFor: 'comanche' stamp: 'gh 10/18/2002 15:37'!
currentToc
	"Get the TOC for the request."

	^req session attributes at: self tocSymbol ifAbsent: [nil]! !

!HVTransientView methodsFor: 'urls' stamp: 'gh 2/11/2002 18:33'!
default
	"This is the default method called on a HttpView if no other
	method is named in the url. It is the base page for the view.
	It should always be implemented. This is a simple test implementation."

	| b |
	b _ self builder.
	b start; h1: 'View for model:'; p: model printString; end.
	^b! !

!HVTransientView methodsFor: 'comanche' stamp: 'gh 2/11/2002 17:39'!
dispatch
	"Dispatch to correct method in this view."

	^self dispatchOn: (self methodAfter: self prefix)


! !

!HVTransientView methodsFor: 'comanche' stamp: 'gh 10/29/2002 17:01'!
dispatchOn: method 
	"Dispatch to correct method:
	- If method is empty we call #default:
	- If self responds then we just call it, otherwise:
		- If method is prefixed with 'tms' we strip that (timing) and try again.
	- If method is prefixed with 'src' we return a HTML page with the source for that method."


	| m |
	method isEmpty ifTrue:[ ^self default ].
	m _ method asSymbol.
	[(self respondsTo: m) ifTrue:[^self perform: m].
	(m beginsWith: 'tms')] whileTrue: [m _ (m last: (m size - 3)) asSymbol].
		
	"Is it a request for the source?"
	((m beginsWith: 'src') and: [self respondsTo: (m asString last: (m size - 3)) asSymbol ])
		ifTrue:[
			m _ (m asString last: (m size - 3)) asSymbol.
			(m beginsWith: 'tms') ifTrue: [m _ (m last: (m size - 3)) asSymbol].
			^self showSourceFor: m]
		ifFalse:[^self class name, ' does not have a method called #', m]

! !

!HVTransientView methodsFor: 'html creation' stamp: 'gh 1/30/2002 15:58'!
endhtml
	"Standard end."

^'</body></html>'! !

!HVTransientView methodsFor: 'html creation' stamp: 'gh 1/30/2002 15:57'!
endhtml: request
	"Standard end. Attach a link to the source of the page."

	| url slash |
	slash _ request url findLast: [:c | c = $/ ].
	url _ (request url copyFrom: 1 to: slash), 'src', (request url copyFrom: slash + 1 to: request url size).
^'<hr><br><font size=-1>', (self link: url text: 'See source for this page'), '</font></body></html>'! !

!HVTransientView methodsFor: 'urls' stamp: 'gh 10/18/2002 15:36'!
expandtoc
	""

	| entryName toc tocString tocSym |
	tocSym _ self tocSymbol.
	entryName _ req getFields at: #entry.
	toc _ req session attributes at: tocSym ifAbsent: [nil].
	toc ifNotNil: [
		toc _ ((toc findTokens: $,) collect: [:s | s asSymbol]) asSet.
		toc add: entryName asSymbol.
		tocString _ String streamContents: [:s |
			toc do: [:sym | s nextPutAll: sym, ',']]]
		ifNil: [toc _ ''].
	req session attributes at: tocSym put: tocString.
	^self redirectToDefault! !

!HVTransientView methodsFor: 'html creation' stamp: 'gh 8/1/2002 18:43'!
fixForHtml: string
	"Replace a lot of characters with HTML friendly stuff."

	| temp |
	(string isEmpty or: [string isNil]) ifTrue:[^string].
	temp _ string copyReplaceAll: '&' with: '&amp;'.
	HtmlEntities keysAndValuesDo:
		[:entity :char |
		char = $& ifFalse:
			[temp _ temp copyReplaceAll: char asString with: '&' , entity , ';']].
	^'<pre>', temp, '</pre>'! !

!HVTransientView methodsFor: 'utilities' stamp: 'gk 10/29/2003 16:12'!
handleUpload: aBlock
	"If the request is a multipart POST we will
	extract the filename for each chunk and
	call aBlock with that filename. If a stream
	is returned from the block we will write the
	chunk to that stream and close it."

	| fileName stream |
	req isPostMultipart ifTrue: [
		req multipartFormFieldsDo: [:chunk |
			chunk fileName isEmptyOrNil ifFalse: [
				fileName _ (chunk fileName findTokens: ':/\') last.
				stream _ aBlock value: fileName.
				stream ifNotNil: [
					[chunk saveToStream: stream]
						ensure: [stream close]]]]]! !

!HVTransientView methodsFor: 'initialize-release' stamp: 'gk 10/24/2003 10:29'!
initialize
	super initialize.
	title _ 'No title set'! !

!HVTransientView methodsFor: 'html creation' stamp: 'gk 10/23/2003 11:39'!
initializeWith: aParent
	"If we have no request set yet, we pick it from our parent.
	If aParent is nil then request is set later in #process: instead."

	aParent ifNotNil: [
		parent _ aParent.
		req ifNil: [req _ parent request]].
	self initialize; postInitialize! !

!HVTransientView methodsFor: 'comanche' stamp: 'gh 2/11/2002 17:34'!
isLoggedIn
	"Check if the user is logged in."

	^req session attributes includesKey: #account! !

!HVTransientView methodsFor: 'accessing' stamp: 'gh 9/20/2002 09:36'!
isTopView
	"Am I a topview?"

	^false! !

!HVTransientView methodsFor: 'html creation' stamp: 'gh 1/28/2002 15:40'!
link: url text: text
	"Return a HTML link."

	^String streamContents: [:stream |
		stream
			nextPutAll: '<a href="';
			nextPutAll: url;
			nextPutAll: '">'; nextPutAll: text; nextPutAll: '</a>' ]
! !

!HVTransientView methodsFor: 'html creation' stamp: 'gh 7/31/2002 16:41'!
linkBase: server local: relativeUrl text: text
	"Return a local HTML link to the view."

	^self link: server, self prefix, relativeUrl text: text
! !

!HVTransientView methodsFor: 'html creation' stamp: 'gh 1/29/2002 15:29'!
linkback: text
	"Return a local backlink."

	^self link: self prefix text: text
! !

!HVTransientView methodsFor: 'html creation' stamp: 'gh 1/29/2002 15:30'!
linkbackparent: text
	"Return a parent backlink."

	^self link: parent prefix text: text
! !

!HVTransientView methodsFor: 'html creation' stamp: 'gh 1/29/2002 15:24'!
linklocal: relativeUrl text: text
	"Return a local HTML link to the view."

	^self link: self prefix, relativeUrl text: text
! !

!HVTransientView methodsFor: 'comanche' stamp: 'gh 5/24/2002 12:23'!
logout
	"Tell the account that it is being logged out.
	Clear out the account attribute in the session.
	Return true if all succeded."

	self currentAccount ifNil: [^true].
	self currentAccount logout.
	req session attributes removeKey: #account ifAbsent: [^false].
	^true! !

!HVTransientView methodsFor: 'html creation' stamp: 'gh 5/24/2002 15:19'!
message: message
	"Return a single page with a message and a back link to base page of this view."

	^self builder start; h1: message; linkBack: 'Back'; end; yourself
! !

!HVTransientView methodsFor: 'simple messages' stamp: 'gk 8/8/2003 17:14'!
message: message backlink: link
	"Return a single page with a message and a hard link back."

	^self builder start; h1: message; html: (self linklocal: link text: 'Back'); end; yourself
! !

!HVTransientView methodsFor: 'simple messages' stamp: 'gh 1/30/2002 13:54'!
message: message link: link
	"Return a single page with a message and a back link relative to this view."

	^self starthtml, '<h1>', message, '</h1>', (self link: link text: 'Back'), self endhtml
! !

!HVTransientView methodsFor: 'simple messages' stamp: 'gh 5/15/2002 10:46'!
message: message linklocal: link
	"Return a single page with a message and a back link relative to this view."

	^self message: message linklocal: link text: 'Back'
! !

!HVTransientView methodsFor: 'simple messages' stamp: 'gh 5/6/2002 15:50'!
message: message linklocal: link text: text
	"Return a single page with a message and a back link relative to this view."

	^self starthtml, '<h1>', message, '</h1>', (self linklocal: '/', link text: text), self endhtml
! !

!HVTransientView methodsFor: 'html creation' stamp: 'gh 5/24/2002 15:22'!
message: message text: text
	"Return a single page with a message and a back link to base page of this view."

	^self builder start; h1: message; linkBack: text; end; yourself
! !

!HVTransientView methodsFor: 'comanche' stamp: 'gk 10/23/2003 15:43'!
methodAfter: aPrefix
	^self methodInUrl: req rawUrl after: aPrefix! !

!HVTransientView methodsFor: 'comanche' stamp: 'gh 2/11/2002 17:39'!
methodInUrl: url after: aPrefix
	"Extracts the method from the url.
	The methodname is after the prefix upto the first $? $/ or end of url like this:
	'/prefix/method/knirk?habbadubba' => 'method'
	'/prefix/method?habbadubba' => 'method'
	'/prefix/method' => 'method'
	'/prefix/' => ''
	'/prefix' => ''"

	| method endq ends |
	(url = aPrefix) ifTrue:[ ^'' ].
	method _ url copyFrom: aPrefix size + 1 to: url size. "cut away prefix"
	(method = '/') ifTrue:[ ^'' ].
	method _ method allButFirst.
	endq _ method indexOf: $?.
	ends _ method indexOf: $/.
	(endq = 0) ifTrue:[ endq _ method size + 1].
	(ends = 0) ifTrue:[ ends _ method size + 1].
	^method copyFrom: 1 to: (ends min: endq) - 1! !

!HVTransientView methodsFor: 'accessing' stamp: 'gh 2/4/2002 14:23'!
parent
	^parent! !

!HVTransientView methodsFor: 'initialize-release' stamp: 'gh 9/20/2002 14:31'!
postInitialize
! !

!HVTransientView methodsFor: 'comanche' stamp: 'gk 10/23/2003 15:35'!
prefix
	"Return the full prefix which is composed by concatenating up the parent chain."

	^String streamContents: [:stream | self prefixOn: stream]! !

!HVTransientView methodsFor: 'comanche' stamp: 'gk 10/24/2003 10:28'!
prefixOn: aStream
	"Return the full prefix which is composed by concatenating up the parent chain."

	parent prefixOn: aStream.
	prefix ifNotNil: [aStream nextPutAll: prefix]! !

!HVTransientView methodsFor: 'comanche' stamp: 'gk 10/22/2003 16:10'!
redirectTo: page
	"Make a redirection to another url."

	^HttpResponse redirectTo: (page isEmpty ifTrue:['/'] ifFalse: [page])! !

!HVTransientView methodsFor: 'comanche' stamp: 'gk 10/22/2003 16:09'!
redirectToDefault
	"Make a redirection to the default url of this view."

	| px |
	px _ self prefix.
"	(px notEmpty and: [px last ~= $/]) ifTrue:[px _ px, '/']."
	^self redirectTo: (px isEmpty ifTrue:['/default'] ifFalse: [px, '/default'])! !

!HVTransientView methodsFor: 'comanche' stamp: 'gh 3/4/2002 16:41'!
redirectToLocal: page
	"Make a redirection to another page in this view."

	^req redirectTo: self prefix, '/', page! !

!HVTransientView methodsFor: 'accessing' stamp: 'gh 2/8/2002 16:28'!
request
	^req! !

!HVTransientView methodsFor: 'accessing' stamp: 'gh 2/8/2002 16:28'!
request: aRequest
	req _ aRequest! !

!HVTransientView methodsFor: 'accessing' stamp: 'gh 9/17/2002 17:16'!
rootView
	"Return the view at the root."

	^parent parent isNil ifTrue: [self] ifFalse: [parent rootView]! !

!HVTransientView methodsFor: 'simple messages' stamp: 'gh 1/14/2002 16:53'!
serverError: aString
	"Return an error to the user."

	^'Error returned by server: ', aString! !

!HVTransientView methodsFor: 'comanche' stamp: 'gh 10/18/2002 15:37'!
setToc: aToc
	"Set the TOC for the request."

	req session attributes at: self tocSymbol put: aToc! !

!HVTransientView methodsFor: 'html creation' stamp: 'gh 1/29/2002 16:13'!
showSourceFor: selector
	"Show the source for given selector."

^self starthtml, '
<h2>Source for ', self class name, '>>', selector, '</h2>
<pre>
', (self fixForHtml: (self class sourceMethodAt: selector) asString), '
</pre>', self endhtml! !

!HVTransientView methodsFor: 'start-stop' stamp: 'gk 10/24/2003 09:13'!
start
	"Start the web app on port 80."

	self startOn: 80! !

!HVTransientView methodsFor: 'html creation' stamp: 'gh 1/29/2002 15:23'!
starthtml
	"Standard start."

^'<html><head><title>', self title, '</title></head><body>'! !

!HVTransientView methodsFor: 'start-stop' stamp: 'gk 10/24/2003 09:14'!
stop
	"Stop service with name of class."

	self class stop! !

!HVTransientView methodsFor: 'accessing' stamp: 'gh 1/28/2002 14:58'!
title
	^title! !

!HVTransientView methodsFor: 'accessing' stamp: 'gh 9/20/2002 12:35'!
topView
	"Return the view that thinks it is a top view."

	^self isTopView ifTrue: [self] ifFalse: [
		parent parent ifNil: [self] ifNotNil: [parent topView]]! !

!HVTransientView methodsFor: 'utilities' stamp: 'gh 5/30/2002 13:42'!
validateSafeString: aString

	aString do: [:c | (SafeChars includes: c) ifFalse:[^false]].
	^true! !

!HVTransientView methodsFor: 'utilities' stamp: 'gh 5/30/2002 13:58'!
validateUltraSafeString: aString

	aString do: [:c | (UltraSafeChars includes: c) ifFalse:[^false]].
	^true! !

Object subclass: #HVTableOfContentsEntry
	instanceVariableNames: 'name label parent children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVTableOfContentsEntry classSide methodsFor: 'instance creation' stamp: 'gh 9/12/2002 16:19'!
name: aSymbol label: aString parent: aToc
	^self new name: aSymbol label: aString parent: aToc! !

!HVTableOfContentsEntry methodsFor: 'rendering' stamp: 'gh 10/17/2002 15:27'!
closedImageUrl
	^parent closedImageUrl! !

!HVTableOfContentsEntry methodsFor: 'rendering' stamp: 'gh 9/18/2002 11:25'!
fullName
	| str |
	str _ parent fullName.
	^(str isEmpty or: [str last = $/]) ifTrue: [str, name] ifFalse: [str, '/', name]! !

!HVTableOfContentsEntry methodsFor: 'rendering' stamp: 'gh 10/17/2002 15:27'!
leafImageUrl
	^parent leafImageUrl! !

!HVTableOfContentsEntry methodsFor: 'entries' stamp: 'gh 9/12/2002 16:27'!
name: aName label: aLabel
	"Add a new top level entry in the TOC.
	Return the entry."

	children ifNil: [children _ OrderedCollection new].
	^children add: (HVTableOfContentsEntry name: aName label: aLabel parent: self)! !

!HVTableOfContentsEntry methodsFor: 'initialize-release' stamp: 'gh 9/17/2002 17:47'!
name: aSymbol label: aString parent: aToc
	name _ aSymbol.
	parent _ aToc.
	label _ aString! !

!HVTableOfContentsEntry methodsFor: 'rendering' stamp: 'gh 10/17/2002 15:27'!
openImageUrl
	^parent openImageUrl! !

!HVTableOfContentsEntry methodsFor: 'rendering' stamp: 'gh 10/18/2002 15:32'!
renderOn: stream expanded: expanded level: aLevel builder: aBuilder
	"Render entry."

	| url view |
	view _ aBuilder view.
	aLevel timesRepeat: [stream nextPutAll: '&nbsp;&nbsp;&nbsp;'].
	url _ self fullName.
	children isEmptyOrNil 
		ifTrue:[stream
				nextPutAll: (aBuilder getLink: url text: (aBuilder getImage: self leafImageUrl));
				nextPutAll: '&nbsp;';
				nextPutAll: (aBuilder getLink: url text: label);
				nextPutAll: '<br />']
		ifFalse:[
			(expanded includes: name)
				ifTrue:[
					stream
						nextPutAll: (view linklocal: '/collapsetoc?entry=', name text: (aBuilder getImage: self openImageUrl));
						nextPutAll: '&nbsp;';
						nextPutAll: (aBuilder getLink: url text: label);
						nextPutAll: '<br />'.
					children do: [:child |
						child renderOn: stream expanded: expanded level: aLevel + 1 builder: aBuilder]]
				ifFalse:[
					stream
						nextPutAll: (view linklocal: '/expandtoc?entry=', name text: (aBuilder getImage: self closedImageUrl));
						nextPutAll: '&nbsp;';
						nextPutAll: (aBuilder getLink: url text: label);
						nextPutAll: '<br />']].
	! !

Object subclass: #HVTodoList
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-sample2'!

!HVTodoList commentStamp: 'gk 10/24/2003 10:58' prior: 0!
This is a very simple domain object for a todolist. I only have an OrderedCollection holding the items and a few simple methods for adding and removing items from the collection.

This class contains no code whatsoever specific to HttpView.!

!HVTodoList class methodsFor: 'instance creation' stamp: 'gh 2/12/2002 10:36'!
new
	^super new initialize! !

!HVTodoList methodsFor: 'items' stamp: 'gh 2/12/2002 10:37'!
addItem: item

	^items add: item! !

!HVTodoList methodsFor: 'initialize-release' stamp: 'gh 2/12/2002 10:36'!
initialize
	items _ OrderedCollection new! !

!HVTodoList methodsFor: 'items' stamp: 'gh 2/12/2002 10:37'!
items

	^items! !

!HVTodoList methodsFor: 'items' stamp: 'gh 2/12/2002 10:37'!
removeItem: item

	^items remove: item! !

!SocketStream methodsFor: '*hv-fixes' stamp: 'JO 5/14/2002 16:13'!
isEmpty
	"Test if there are more data to read"
	^inStream isEmpty and: [self isDataAvailable not]! !

!SocketStream methodsFor: '*hv-fixes' stamp: 'gk 10/24/2003 15:43'!
match: aString
	"Position past the occurrence of aString
	if aString is matched at current position.
	If it is not matched the position is not changed.
	Answer true if found, false otherwise."

	| oldPos |
	self receiveData: aString size.
	oldPos _ inStream position.
	(inStream match: aString)
		ifTrue: [
			inStream position: oldPos.
			self next: aString size.
			^true]
		ifFalse: [
			inStream position: oldPos.
			^false]! !

!SocketStream methodsFor: '*hv-fixes' stamp: 'gk 10/24/2003 15:42'!
nextChunk
	"Return some data. If there is data in the inStream
	we return that, otherwise we receive some data and
	recursively try again."

	self inStream atEnd ifFalse: [^self inStream upToEnd].
	self receiveData.
	^self nextChunk! !

!SocketStream methodsFor: '*hv-fixes' stamp: 'gk 10/24/2003 14:16'!
receiveData: nBytes
	"Keep reading the socket until we have nBytes in the inStream."

	[self atEnd not and: [self inStream size < nBytes]]
		whileTrue: [self receiveData]! !

!SocketStream methodsFor: '*hv-fixes' stamp: 'mir 5/9/2003 18:17'!
upTo: delim 
	| resultStream nextChar |
	resultStream _ WriteStream on: (String new: 100).

	[(nextChar _ self next) = delim]
		whileFalse: [
			nextChar
				ifNil: [^resultStream contents]
				ifNotNil: [resultStream nextPut: nextChar]].

	^resultStream contents! !

!TimeStamp methodsFor: '*hv-fixes' stamp: 'gk 8/14/2003 14:44'!
printOnHTTP: aStream
	"Print receiver's date and time on aStream in HTTP format;
	'<day>, DD <mth> YYYY HH:MM:SS GMT' ->	'Thu, 01 Dec 1994 16:00:00 GMT'
	"

	aStream
		nextPutAll: (date weekday copyFrom: 1 to: 3);
		nextPutAll: ', ';
		nextPutAll: (date dayOfMonth asString padded: #left to: 2 with: $0);
		nextPut: $ ;
		nextPutAll: (date monthName copyFrom: 1 to: 3);
		nextPut: $ ;
		nextPutAll: date year asString;
		nextPut: $ .
	time printOn: aStream.
	aStream nextPutAll: ' GMT'! !

!MIMEDocument class methodsFor: '*hv-fixes' stamp: 'gh 8/30/2002 10:21'!
contentTypeTextCSS
	^'text/css'! !

!HttpRequest methodsFor: '*hv-fixes' stamp: 'gk 11/3/2003 13:14'!
isPostMultipart
	"Is this request a POST with multipart form data?"

	^self isPostRequest and: [self contentType = MIMEDocument contentTypeMultipart]! !
HVHttpView initialize!
